{ Parsed from Uikit.framework UIAccelerometer.h }

{$ifdef TYPES}
{$ifndef UIACCELEROMETER_PAS_T}
{$define UIACCELEROMETER_PAS_T}

{ Types }
type
  UIAccelerationValue = double;
  UIAccelerationValuePtr = ^UIAccelerationValue;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIACCELEROMETER_PAS_R}
{$define UIACCELEROMETER_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIACCELEROMETER_PAS_F}
{$define UIACCELEROMETER_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIACCELEROMETER_PAS_S}
{$define UIACCELEROMETER_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIAccelerometerDelegateProtocol = objcprotocol;
  UIAcceleration = objcclass;
  UIAccelerationPointer = ^UIAcceleration;
  UIAccelerationPtr = UIAccelerationPointer;
  UIAccelerometer = objcclass;
  UIAccelerometerPointer = ^UIAccelerometer;
  UIAccelerometerPtr = UIAccelerometerPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIACCELEROMETER_PAS_C}
{$define UIACCELEROMETER_PAS_C}

{ UIAcceleration }
  UIAcceleration = objcclass external (NSObject)
  private
    timestamp: NSTimeInterval;
    x, y, z: UIAccelerationValue;
    
  public
    function timestamp_: NSTimeInterval; message 'timestamp_';
    function x_: UIAccelerationValue; message 'x_';
    function y_: UIAccelerationValue; message 'y_';
    function z_: UIAccelerationValue; message 'z_';
  end;

{ UIAccelerometer }
  UIAccelerometer = objcclass external (NSObject)
  private
    _updateInterval: NSTimeInterval;
    _delegate: UIAccelerometerDelegateProtocol;
    __accelerometerFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIAccelerometer0: cuint);
       1: (
        delegateDidAccelerate: 0..1;
        reserved: 0..((1 shl 31)-1);
      );
      end;
    
  public
    class function sharedAccelerometer: UIAccelerometer; message 'sharedAccelerometer';
    procedure setUpdateInterval (newValue: NSTimeInterval); message 'setUpdateInterval:';
    function updateInterval: NSTimeInterval; message 'updateInterval';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIACCELEROMETER_PAS_P}
{$define UIACCELEROMETER_PAS_P}
  
{ UIAccelerometerDelegate Protocol }
  UIAccelerometerDelegateProtocol = objcprotocol external name 'UIAccelerometerDelegate'
  optional
    procedure accelerometer_didAccelerate(accelerometer: UIAccelerometer; acceleration: UIAcceleration); message 'accelerometer:didAccelerate:';
  end;
{$endif}
{$endif}
