{ Parsed from Uikit.framework UIActionSheet.h }

{$ifdef TYPES}
{$ifndef UIACTIONSHEET_PAS_T}
{$define UIACTIONSHEET_PAS_T}

{ Types }
type
  
  UIActionSheetStyle = culong;

{ Constants }

const
  UIActionSheetStyleAutomatic = -1;
  UIActionSheetStyleDefault = UIBarStyleDefault;
  UIActionSheetStyleBlackTranslucent = UIBarStyleBlackTranslucent;
  UIActionSheetStyleBlackOpaque = UIBarStyleBlackOpaque;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIACTIONSHEET_PAS_R}
{$define UIACTIONSHEET_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIACTIONSHEET_PAS_F}
{$define UIACTIONSHEET_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIACTIONSHEET_PAS_S}
{$define UIACTIONSHEET_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIActionSheetDelegateProtocol = objcprotocol;
  UIActionSheet = objcclass;
  UIActionSheetPointer = ^UIActionSheet;
  UIActionSheetPtr = UIActionSheetPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIACTIONSHEET_PAS_C}
{$define UIACTIONSHEET_PAS_C}

{ UIActionSheet }
  UIActionSheet = objcclass external (UIView)
  private
    _delegate: UIActionSheetDelegateProtocol;
    _titleLabel: UILabel;
    _subtitleLabel: UILabel;
    _bodyTextLabel: UILabel;
    _taglineTextLabel: UILabel;
    _startY: CGFloat;
    _context: id;
    _cancelButton: NSInteger;
    _defaultButton: NSInteger;
    _firstOtherButton: NSInteger;
    _toolbar: UIToolbar;
    _originalWindow: UIWindow;
    _dimWindow: UIWindow;
    _suspendTag: NSInteger;
    _dismissButtonIndex: NSInteger;
    _bodyTextHeight: CGFloat;
    _buttons: NSMutableArray;
    _buttonsInTable: NSMutableArray;
    _textFields: NSMutableArray;
    _keyboard: UIView;
    _table: UIView;
    _buttonTableView: UIView;
    _dimView: UIView;
    _popoverController: UIPopoverController;
    _fontSizeInTableView: CGFloat;
    _iconOffset: CGFloat;
    _labelOffset: CGFloat;
    _labelWidth: CGFloat;
    _titleWidth: CGFloat;
    _oldIgnoreTapsValue: Boolean;
    __modalViewFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIActionSheet0: cuint);
       1: (
        numberOfRows: 0..((1 shl 7)-1);
        delegateAlertSheetButtonClicked: 0..1;
        delegateDidPresentAlertSheet: 0..1;
        delegateDidDismissAlertSheet: 0..1;
        hideButtonBar: 0..1;
        alertStyle: 0..((1 shl 3)-1);
        dontDimBackground: 0..1;
        dismissSuspended: 0..1;
        dontBlockInteraction: 0..1;
        sheetWasPoppedUp: 0..1;
        sheetWasShown: 0..1;
        animating: 0..1;
        hideWhenDoneAnimating: 0..1;
        layoutWhenDoneAnimating: 0..1;
        titleMaxLineCount: 0..((1 shl 2)-1);
        bodyTextMaxLineCount: 0..((1 shl 3)-1);
        runsModal: 0..1;
        runningModal: 0..1;
        addedTextView: 0..1;
        addedTableShadows: 0..1;
        showOverSBAlerts: 0..1;
        
        showMinTableContent: 0..1;
        bodyTextTruncated: 0..1;
        orientation: 0..((1 shl 3)-1);
        popupFromPoint: 0..1;
        inPopover: 0..1;
        delegateBodyTextAlignment: 0..1;
        delegateClickedButtonAtIndex: 0..1;
        delegateClickedButtonAtIndex2: 0..1;
        delegateCancel: 0..1;
        delegateCancel2: 0..1;
        delegateWillPresent: 0..1;
        delegateWillPresent2: 0..1;
        delegateDidPresent: 0..1;
        delegateDidPresent2: 0..1;
        delegateWillDismiss: 0..1;
        delegateWillDismiss2: 0..1;
        delegateDidDismiss: 0..1;
        delegateDidDismiss2: 0..1;
        dontCallDismissDelegate: 0..1;
        useAutomaticKB: 0..1;
        twoColumnsLayoutMode: 0..((1 shl 7)-1);
        shouldHandleFirstKeyUpEvent: 0..1;
        cancelWhenDoneAnimating: 0..1;
        useThreePartButtons: 0..1;
        useTwoPartButtons: 0..1;
        displaySelectedButtonGlyph: 0..1;
        indexOfSelectedButton: 0..((1 shl 7)-1);
        useCustomSelectedButtonGlyph: 0..1;
      );
      end;
    _actionSheetStyle: UIActionSheetStyle;
    _selectedButtonGlyphImage: UIImage;
    _selectedButtonGlyphHighlightedImage: UIImage;
    
  public
    function initWithTitle_delegate_cancelButtonTitle_destructiveButtonTitle_otherButtonTitles(title: NSString; delegate: UIActionSheetDelegateProtocol; cancelButtonTitle: NSString; destructiveButtonTitle: NSString; firstKey: id): id; varargs; message 'initWithTitle:delegate:cancelButtonTitle:destructiveButtonTitle:otherButtonTitles:';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setTitle (newValue: NSString); message 'setTitle:';
    function title: NSString; message 'title';
    procedure setActionSheetStyle (newValue: UIActionSheetStyle); message 'setActionSheetStyle:';
    function actionSheetStyle: UIActionSheetStyle; message 'actionSheetStyle';
    function addButtonWithTitle(title_: NSString): NSInteger; message 'addButtonWithTitle:';
    function buttonTitleAtIndex(buttonIndex: NSInteger): NSString; message 'buttonTitleAtIndex:';
    function numberOfButtons: NSInteger; message 'numberOfButtons';
    procedure setCancelButtonIndex (newValue: NSInteger); message 'setCancelButtonIndex:';
    function cancelButtonIndex: NSInteger; message 'cancelButtonIndex';
    procedure setDestructiveButtonIndex (newValue: NSInteger); message 'setDestructiveButtonIndex:';
    function destructiveButtonIndex: NSInteger; message 'destructiveButtonIndex';
    function firstOtherButtonIndex: NSInteger; message 'firstOtherButtonIndex';
    function isVisible: Boolean; message 'isVisible';
    procedure showFromToolbar(view: UIToolbar); message 'showFromToolbar:';
    procedure showFromTabBar(view: UITabBar); message 'showFromTabBar:';
    procedure showFromBarButtonItem_animated(item: UIBarButtonItem; animated: Boolean); message 'showFromBarButtonItem:animated:';
    procedure showFromRect_inView_animated(rect: CGRect; view: UIView; animated: Boolean); message 'showFromRect:inView:animated:';
    procedure showInView(view: UIView); message 'showInView:';
    procedure dismissWithClickedButtonIndex_animated(buttonIndex: NSInteger; animated: Boolean); message 'dismissWithClickedButtonIndex:animated:';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIACTIONSHEET_PAS_P}
{$define UIACTIONSHEET_PAS_P}
  
{ UIActionSheetDelegate Protocol }
  UIActionSheetDelegateProtocol = objcprotocol external name 'UIActionSheetDelegate'
  optional
    procedure actionSheet_clickedButtonAtIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:clickedButtonAtIndex:';
    procedure actionSheetCancel(actionSheet: UIActionSheet); message 'actionSheetCancel:';
    procedure willPresentActionSheet(actionSheet: UIActionSheet); message 'willPresentActionSheet:';
    procedure didPresentActionSheet(actionSheet: UIActionSheet); message 'didPresentActionSheet:';
    procedure actionSheet_willDismissWithButtonIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:willDismissWithButtonIndex:';
    procedure actionSheet_didDismissWithButtonIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger); message 'actionSheet:didDismissWithButtonIndex:';
  end;
{$endif}
{$endif}
