{ Parsed from Uikit.framework UIApplication.h }

{$ifdef TYPES}
{$ifndef UIAPPLICATION_PAS_T}
{$define UIAPPLICATION_PAS_T}

{ Types }
type
  
  UIStatusBarStyle = culong;
  UIStatusBarAnimation = culong;
  UIInterfaceOrientation = culong;
  UIRemoteNotificationType = culong;
  UIApplicationState = culong;

{ Constants }

const
  UIStatusBarStyleDefault = 0;
  UIStatusBarStyleBlackTranslucent = 1;
  UIStatusBarStyleBlackOpaque = 2;

const
  UIStatusBarAnimationNone = 0;
  UIStatusBarAnimationFade = 1;
  UIStatusBarAnimationSlide = 2;

const
  UIInterfaceOrientationPortrait = UIDeviceOrientationPortrait;
  UIInterfaceOrientationPortraitUpsideDown = UIDeviceOrientationPortraitUpsideDown;
  UIInterfaceOrientationLandscapeLeft = UIDeviceOrientationLandscapeRight;
  UIInterfaceOrientationLandscapeRight = UIDeviceOrientationLandscapeLeft;

const
  UIRemoteNotificationTypeNone = 0;
  UIRemoteNotificationTypeBadge = 1 shl 0;
  UIRemoteNotificationTypeSound = 1 shl 1;
  UIRemoteNotificationTypeAlert = 1 shl 2;

const
  UIApplicationStateActive = 0;
  UIApplicationStateInactive = 1;
  UIApplicationStateBackground = 2;

{ Types }
type
  UIBackgroundTaskIdentifier = NSUInteger;
  UIBackgroundTaskIdentifierPtr = ^UIBackgroundTaskIdentifier;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIAPPLICATION_PAS_R}
{$define UIAPPLICATION_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIAPPLICATION_PAS_F}
{$define UIAPPLICATION_PAS_F}

{ Functions }
function UIApplicationMain(argc: cint; argv: PPChar {array of PChar}; principalClassName: NSString; delegateClassName: NSString): cint; cdecl; external;

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIAPPLICATION_PAS_S}
{$define UIAPPLICATION_PAS_S}

{ External symbols }
var
  UIBackgroundTaskInvalid: UIBackgroundTaskIdentifier; cvar; external;
  UIMinimumKeepAliveTimeout: NSTimeInterval; cvar; external;

{ External string constants }
var
  UITrackingRunLoopMode: NSString; cvar; external;
  UIApplicationDidEnterBackgroundNotification: NSString; cvar; external;
  UIApplicationWillEnterForegroundNotification: NSString; cvar; external;
  UIApplicationDidFinishLaunchingNotification: NSString; cvar; external;
  UIApplicationDidBecomeActiveNotification: NSString; cvar; external;
  UIApplicationWillResignActiveNotification: NSString; cvar; external;
  UIApplicationDidReceiveMemoryWarningNotification: NSString; cvar; external;
  UIApplicationWillTerminateNotification: NSString; cvar; external;
  UIApplicationSignificantTimeChangeNotification: NSString; cvar; external;
  UIApplicationWillChangeStatusBarOrientationNotification: NSString; cvar; external;
  UIApplicationDidChangeStatusBarOrientationNotification: NSString; cvar; external;
  UIApplicationStatusBarOrientationUserInfoKey: NSString; cvar; external;
  UIApplicationWillChangeStatusBarFrameNotification: NSString; cvar; external;
  UIApplicationDidChangeStatusBarFrameNotification: NSString; cvar; external;
  UIApplicationStatusBarFrameUserInfoKey: NSString; cvar; external;
  UIApplicationLaunchOptionsURLKey: NSString; cvar; external;
  UIApplicationLaunchOptionsSourceApplicationKey: NSString; cvar; external;
  UIApplicationLaunchOptionsRemoteNotificationKey: NSString; cvar; external;
  UIApplicationLaunchOptionsLocalNotificationKey: NSString; cvar; external;
  UIApplicationLaunchOptionsAnnotationKey: NSString; cvar; external;
  UIApplicationProtectedDataWillBecomeUnavailable: NSString; cvar; external;
  UIApplicationProtectedDataDidBecomeAvailable: NSString; cvar; external;
  UIApplicationLaunchOptionsLocationKey: NSString; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UIApplicationDelegateProtocol = objcprotocol;
  UIApplication = objcclass;
  UIApplicationPointer = ^UIApplication;
  UIApplicationPtr = UIApplicationPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIAPPLICATION_PAS_C}
{$define UIAPPLICATION_PAS_C}

{ UIApplication }
  UIApplication = objcclass external (UIResponder, UIActionSheetDelegateProtocol)
  private
    _delegate: UIApplicationDelegateProtocol;
    _touchMap: CFMutableDictionaryRef;
    _exclusiveTouchWindows: NSMutableSet;
    _event: UIEvent;
    _touchesEvent: UIEvent;
    _motionEvent: UIEvent;
    _remoteControlEvent: UIEvent;
    _remoteControlEventObservers: NSInteger;
    _topLevelNibObjects: NSArray;
    _networkResourcesCurrentlyLoadingCount: NSInteger;
    _hideNetworkActivityIndicatorTimer: NSTimer;
    _editAlertView: id;
    _statusBar: UIStatusBar;
    _statusBarWindow: UIStatusBarWindow;
    __applicationFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIApplication0: cuint);
       1: (
        isActive: 0..1;
        isSuspended: 0..1;
        isSuspendedEventsOnly: 0..1;
        isLaunchedSuspended: 0..1;
        calledNonSuspendedLaunchDelegate: 0..1;
        isHandlingURL: 0..1;
        isHandlingRemoteNotification: 0..1;
        isHandlingLocalNotification: 0..1;
        statusBarShowsProgress: 0..1;
        statusBarRequestedStyle: 0..((1 shl 4)-1);
        statusBarHidden: 0..1;
        blockInteractionEvents: 0..((1 shl 4)-1);
        receivesMemoryWarnings: 0..1;
        showingProgress: 0..1;
        receivesPowerMessages: 0..1;
        launchEventReceived: 0..1;
        isAnimatingSuspensionOrResumption: 0..1;
        isResuming: 0..1;
        isSuspendedUnderLock: 0..1;
        isRunningInTaskSwitcher: 0..1;
        shouldExitAfterSendSuspend: 0..1;
        shouldExitAfterTaskCompletion: 0..1;
        terminating: 0..1;
        isHandlingShortCutURL: 0..1;
        idleTimerDisabled: 0..1;
        deviceOrientation: 0..((1 shl 3)-1);
        delegateShouldBeReleasedUponSet: 0..1;
        delegateHandleOpenURL: 0..1;
        delegateOpenURL: 0..1;
        delegateDidReceiveMemoryWarning: 0..1;
        delegateWillTerminate: 0..1;
        delegateSignificantTimeChange: 0..1;
        delegateWillChangeInterfaceOrientation: 0..1;
        delegateDidChangeInterfaceOrientation: 0..1;
        delegateWillChangeStatusBarFrame: 0..1;
        delegateDidChangeStatusBarFrame: 0..1;
        delegateDeviceAccelerated: 0..1;
        delegateDeviceChangedOrientation: 0..1;
        delegateDidBecomeActive: 0..1;
        delegateWillResignActive: 0..1;
        delegateDidEnterBackground: 0..1;
        delegateWillEnterForeground: 0..1;
        delegateWillSuspend: 0..1;
        delegateDidResume: 0..1;
        userDefaultsSyncDisabled: 0..1;
        headsetButtonClickCount: 0..((1 shl 4)-1);
        isHeadsetButtonDown: 0..1;
        isFastForwardActive: 0..1;
        isRewindActive: 0..1;
        disableViewGroupOpacity: 0..1;
        disableViewEdgeAntialiasing: 0..1;
        shakeToEdit: 0..1;
        isClassic: 0..1;
        zoomInClassicMode: 0..1;
        ignoreHeadsetClicks: 0..1;
        touchRotationDisabled: 0..1;
        taskSuspendingUnsupported: 0..1;
        isUnitTests: 0..1;
        requiresHighResolution: 0..1;
        disableViewContentScaling: 0..1;
        singleUseLaunchOrientation: 0..((1 shl 3)-1);
        defaultInterfaceOrientation: 0..((1 shl 3)-1);
      );
      end;
    
  public
    class function sharedApplication: UIApplication; message 'sharedApplication';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure beginIgnoringInteractionEvents; message 'beginIgnoringInteractionEvents';
    procedure endIgnoringInteractionEvents; message 'endIgnoringInteractionEvents';
    function isIgnoringInteractionEvents: Boolean; message 'isIgnoringInteractionEvents';
    procedure setIdleTimerDisabled (newValue: Boolean); message 'setIdleTimerDisabled:';
    function isIdleTimerDisabled: Boolean; message 'isIdleTimerDisabled';
    function openURL(url: NSURL): Boolean; message 'openURL:';
    function canOpenURL(url: NSURL): Boolean; message 'canOpenURL:';
    procedure sendEvent(event: UIEvent); message 'sendEvent:';
    function keyWindow: UIWindow; message 'keyWindow';
    function windows: NSArray; message 'windows';
    function sendAction_to_from_forEvent(action: SEL; target: id; sender: id; event: UIEvent): Boolean; message 'sendAction:to:from:forEvent:';
    procedure setNetworkActivityIndicatorVisible (newValue: Boolean); message 'setNetworkActivityIndicatorVisible:';
    function isNetworkActivityIndicatorVisible: Boolean; message 'isNetworkActivityIndicatorVisible';
    procedure setStatusBarStyle (newValue: UIStatusBarStyle); message 'setStatusBarStyle:';
    function statusBarStyle: UIStatusBarStyle; message 'statusBarStyle';
    procedure setStatusBarStyle_animated(statusBarStyle_: UIStatusBarStyle; animated: Boolean); message 'setStatusBarStyle:animated:';
    procedure setStatusBarHidden (newValue: Boolean); message 'setStatusBarHidden:';
    function isStatusBarHidden: Boolean; message 'isStatusBarHidden';
    procedure setStatusBarHidden_withAnimation(hidden: Boolean; animation: UIStatusBarAnimation); message 'setStatusBarHidden:withAnimation:';
    procedure setStatusBarOrientation (newValue: UIInterfaceOrientation); message 'setStatusBarOrientation:';
    function statusBarOrientation: UIInterfaceOrientation; message 'statusBarOrientation';
    procedure setStatusBarOrientation_animated(interfaceOrientation: UIInterfaceOrientation; animated: Boolean); message 'setStatusBarOrientation:animated:';
    function statusBarOrientationAnimationDuration: NSTimeInterval; message 'statusBarOrientationAnimationDuration';
    function statusBarFrame: CGRect; message 'statusBarFrame';
    procedure setApplicationIconBadgeNumber (newValue: NSInteger); message 'setApplicationIconBadgeNumber:';
    function applicationIconBadgeNumber: NSInteger; message 'applicationIconBadgeNumber';
    procedure setApplicationSupportsShakeToEdit (newValue: Boolean); message 'setApplicationSupportsShakeToEdit:';
    function applicationSupportsShakeToEdit: Boolean; message 'applicationSupportsShakeToEdit';
    function applicationState: UIApplicationState; message 'applicationState';
    function backgroundTimeRemaining: NSTimeInterval; message 'backgroundTimeRemaining';
    // function beginBackgroundTaskWithExpirationHandler(handler: void(^)(void)): UIBackgroundTaskIdentifier; message 'beginBackgroundTaskWithExpirationHandler:';
    procedure endBackgroundTask(identifier: UIBackgroundTaskIdentifier); message 'endBackgroundTask:';
    // function setKeepAliveTimeout_handler(timeout: NSTimeInterval; keepAliveHandler: void(^)(void)): Boolean; message 'setKeepAliveTimeout:handler:';
    procedure clearKeepAliveTimeout; message 'clearKeepAliveTimeout';
    function isProtectedDataAvailable: Boolean; message 'isProtectedDataAvailable';

    { Adopted Protocols }
    procedure actionSheet_clickedButtonAtIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger);
    procedure actionSheetCancel(actionSheet: UIActionSheet);
    procedure willPresentActionSheet(actionSheet: UIActionSheet);
    procedure didPresentActionSheet(actionSheet: UIActionSheet);
    procedure actionSheet_willDismissWithButtonIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger);
    procedure actionSheet_didDismissWithButtonIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger);
  end;

{ UIRemoteNotificationsCategory }
  UIRemoteNotificationsCategory = objccategory external (UIApplication)
    procedure registerForRemoteNotificationTypes(types: UIRemoteNotificationType); message 'registerForRemoteNotificationTypes:';
    procedure unregisterForRemoteNotifications; message 'unregisterForRemoteNotifications';
    function enabledRemoteNotificationTypes: UIRemoteNotificationType; message 'enabledRemoteNotificationTypes';
  end;

{ UILocalNotificationsCategory }
  UILocalNotificationsCategory = objccategory external (UIApplication)
    procedure presentLocalNotificationNow(notification: UILocalNotification); message 'presentLocalNotificationNow:';
    procedure scheduleLocalNotification(notification: UILocalNotification); message 'scheduleLocalNotification:';
    procedure cancelLocalNotification(notification: UILocalNotification); message 'cancelLocalNotification:';
    procedure cancelAllLocalNotifications; message 'cancelAllLocalNotifications';
    procedure setScheduledLocalNotifications (newValue: NSArray); message 'setScheduledLocalNotifications:';
    function scheduledLocalNotifications: NSArray; message 'scheduledLocalNotifications';
  end;

{ UIRemoteControlEventsCategory }
  UIRemoteControlEventsCategory = objccategory external (UIApplication)
    procedure beginReceivingRemoteControlEvents; message 'beginReceivingRemoteControlEvents';
    procedure endReceivingRemoteControlEvents; message 'endReceivingRemoteControlEvents';
  end;

{ UIApplicationDeprecatedCategory }
  UIApplicationDeprecatedCategory = objccategory external (UIApplication)
    procedure setProximitySensingEnabled (newValue: Boolean); message 'setProximitySensingEnabled:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function isProximitySensingEnabled: Boolean; message 'isProximitySensingEnabled'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setStatusBarHidden_animated(hidden: Boolean; animated: Boolean); message 'setStatusBarHidden:animated:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIAPPLICATION_PAS_P}
{$define UIAPPLICATION_PAS_P}
  
{ UIApplicationDelegate Protocol }
  UIApplicationDelegateProtocol = objcprotocol external name 'UIApplicationDelegate'
  optional
    procedure applicationDidFinishLaunching(application: UIApplication); message 'applicationDidFinishLaunching:';
    function application_didFinishLaunchingWithOptions(application: UIApplication; launchOptions: NSDictionary): Boolean; message 'application:didFinishLaunchingWithOptions:';
    procedure applicationDidBecomeActive(application: UIApplication); message 'applicationDidBecomeActive:';
    procedure applicationWillResignActive(application: UIApplication); message 'applicationWillResignActive:';
    function application_handleOpenURL(application: UIApplication; url: NSURL): Boolean; message 'application:handleOpenURL:';
    function application_openURL_sourceApplication_annotation(application: UIApplication; url: NSURL; sourceApplication: NSString; annotation: id): Boolean; message 'application:openURL:sourceApplication:annotation:';
    procedure applicationDidReceiveMemoryWarning(application: UIApplication); message 'applicationDidReceiveMemoryWarning:';
    procedure applicationWillTerminate(application: UIApplication); message 'applicationWillTerminate:';
    procedure applicationSignificantTimeChange(application: UIApplication); message 'applicationSignificantTimeChange:';
    procedure application_willChangeStatusBarOrientation_duration(application: UIApplication; newStatusBarOrientation: UIInterfaceOrientation; duration: NSTimeInterval); message 'application:willChangeStatusBarOrientation:duration:';
    procedure application_didChangeStatusBarOrientation(application: UIApplication; oldStatusBarOrientation: UIInterfaceOrientation); message 'application:didChangeStatusBarOrientation:';
    procedure application_willChangeStatusBarFrame(application: UIApplication; newStatusBarFrame: CGRect); message 'application:willChangeStatusBarFrame:';
    procedure application_didChangeStatusBarFrame(application: UIApplication; oldStatusBarFrame: CGRect); message 'application:didChangeStatusBarFrame:';
    procedure application_didRegisterForRemoteNotificationsWithDeviceToken(application: UIApplication; deviceToken: NSData); message 'application:didRegisterForRemoteNotificationsWithDeviceToken:';
    procedure application_didFailToRegisterForRemoteNotificationsWithError(application: UIApplication; error: NSError); message 'application:didFailToRegisterForRemoteNotificationsWithError:';
    procedure application_didReceiveRemoteNotification(application: UIApplication; userInfo: NSDictionary); message 'application:didReceiveRemoteNotification:';
    procedure application_didReceiveLocalNotification(application: UIApplication; notification: UILocalNotification); message 'application:didReceiveLocalNotification:';
    procedure applicationDidEnterBackground(application: UIApplication); message 'applicationDidEnterBackground:';
    procedure applicationWillEnterForeground(application: UIApplication); message 'applicationWillEnterForeground:';
    procedure applicationProtectedDataWillBecomeUnavailable(application: UIApplication); message 'applicationProtectedDataWillBecomeUnavailable:';
    procedure applicationProtectedDataDidBecomeAvailable(application: UIApplication); message 'applicationProtectedDataDidBecomeAvailable:';
  end;
{$endif}
{$endif}
