{ Parsed from Uikit.framework UIBarButtonItem.h }

{$ifdef TYPES}
{$ifndef UIBARBUTTONITEM_PAS_T}
{$define UIBARBUTTONITEM_PAS_T}

{ Types }
type
  
  UIBarButtonItemStyle = culong;
  UIBarButtonSystemItem = culong;

{ Constants }

const
  UIBarButtonItemStylePlain = 0;
  UIBarButtonItemStyleBordered = 1;
  UIBarButtonItemStyleDone = 2;

const
  UIBarButtonSystemItemDone = 0;
  UIBarButtonSystemItemCancel = 1;
  UIBarButtonSystemItemEdit = 2;
  UIBarButtonSystemItemSave = 3;
  UIBarButtonSystemItemAdd = 4;
  UIBarButtonSystemItemFlexibleSpace = 5;
  UIBarButtonSystemItemFixedSpace = 6;
  UIBarButtonSystemItemCompose = 7;
  UIBarButtonSystemItemReply = 8;
  UIBarButtonSystemItemAction = 9;
  UIBarButtonSystemItemOrganize = 10;
  UIBarButtonSystemItemBookmarks = 11;
  UIBarButtonSystemItemSearch = 12;
  UIBarButtonSystemItemRefresh = 13;
  UIBarButtonSystemItemStop = 14;
  UIBarButtonSystemItemCamera = 15;
  UIBarButtonSystemItemTrash = 16;
  UIBarButtonSystemItemPlay = 17;
  UIBarButtonSystemItemPause = 18;
  UIBarButtonSystemItemRewind = 19;
  UIBarButtonSystemItemFastForward = 20;
  UIBarButtonSystemItemUndo = 21;
  UIBarButtonSystemItemRedo = 22;
  UIBarButtonSystemItemPageCurl = 23;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIBARBUTTONITEM_PAS_R}
{$define UIBARBUTTONITEM_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIBARBUTTONITEM_PAS_F}
{$define UIBARBUTTONITEM_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIBARBUTTONITEM_PAS_S}
{$define UIBARBUTTONITEM_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIBarButtonItem = objcclass;
  UIBarButtonItemPointer = ^UIBarButtonItem;
  UIBarButtonItemPtr = UIBarButtonItemPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIBARBUTTONITEM_PAS_C}
{$define UIBARBUTTONITEM_PAS_C}

{ UIBarButtonItem }
  UIBarButtonItem = objcclass external (UIBarItem)
  private
    _title: NSString;
    _possibleTitles: NSSet;
    _action: SEL;
    _target: id;
    _image: UIImage;
    _miniImage: UIImage;
    _imageInsets: UIEdgeInsets;
    _miniImageInsets: UIEdgeInsets;
    _width: CGFloat;
    _view: UIView;
    _tag: NSInteger;
    __barButtonItemFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIBarButtonItem0: cuint);
       1: (
        enabled: 0..1;
        style: 0..((1 shl 3)-1);
        isSystemItem: 0..1;
        systemItem: 0..((1 shl 7)-1);
        viewIsCustom: 0..1;
        isMinibarView: 0..1;
        disableAutosizing: 0..1;
        selected: 0..1;
      );
      end;
    
  public
    function initWithImage_style_target_action(image_: UIImage; style: UIBarButtonItemStyle; target: id; action: SEL): id; message 'initWithImage:style:target:action:';
    function initWithTitle_style_target_action(title_: NSString; style: UIBarButtonItemStyle; target: id; action: SEL): id; message 'initWithTitle:style:target:action:';
    function initWithBarButtonSystemItem_target_action(systemItem: UIBarButtonSystemItem; target: id; action: SEL): id; message 'initWithBarButtonSystemItem:target:action:';
    function initWithCustomView(customView: UIView): id; message 'initWithCustomView:';
    procedure setStyle (newValue: UIBarButtonItemStyle); message 'setStyle:';
    function style: UIBarButtonItemStyle; message 'style';
    procedure setWidth (newValue: CGFloat); message 'setWidth:';
    function width: CGFloat; message 'width';
    procedure setPossibleTitles (newValue: NSSet); message 'setPossibleTitles:';
    function possibleTitles: NSSet; message 'possibleTitles';
    procedure setCustomView (newValue: UIView); message 'setCustomView:';
    function customView: UIView; message 'customView';
    procedure setAction (newValue: SEL); message 'setAction:';
    function action: SEL; message 'action';
    procedure setTarget (newValue: id); message 'setTarget:';
    function target: id; message 'target';
  end;

{$endif}
{$endif}
