{ Parsed from Uikit.framework UIBezierPath.h }

{$ifdef TYPES}
{$ifndef UIBEZIERPATH_PAS_T}
{$define UIBEZIERPATH_PAS_T}

{ Constants }

const
  UIRectCornerTopLeft = 1 shl 0;
  UIRectCornerTopRight = 1 shl 1;
  UIRectCornerBottomLeft = 1 shl 2;
  UIRectCornerBottomRight = 1 shl 3;

{ Types }
type
  UIRectCorner = NSUInteger;
  UIRectCornerPtr = ^UIRectCorner;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIBEZIERPATH_PAS_R}
{$define UIBEZIERPATH_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIBEZIERPATH_PAS_F}
{$define UIBEZIERPATH_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIBEZIERPATH_PAS_S}
{$define UIBEZIERPATH_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIBezierPath = objcclass;
  UIBezierPathPointer = ^UIBezierPath;
  UIBezierPathPtr = UIBezierPathPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIBEZIERPATH_PAS_C}
{$define UIBEZIERPATH_PAS_C}

{ UIBezierPath }
  UIBezierPath = objcclass external (NSObject, NSCopyingProtocol, NSCodingProtocol)
  private
    _path: CGPathRef;
    _lineDashPattern: CGFloatPtr;
    _lineDashPatternCount: NSUInteger;
    _lineWidth, _miterLimit, _flatness, _lineDashPhase: CGFloat;
    _lineCapStyle: CGLineCap;
    _lineJoinStyle: CGLineJoin;
    _usesEvenOddFillRule: Boolean;
    _immutablePath: CGPathRef;
    _immutablePathIsValid: Boolean;
    
  public
    class function bezierPath: UIBezierPath; message 'bezierPath';
    class function bezierPathWithRect(rect: CGRect): UIBezierPath; message 'bezierPathWithRect:';
    class function bezierPathWithOvalInRect(rect: CGRect): UIBezierPath; message 'bezierPathWithOvalInRect:';
    class function bezierPathWithRoundedRect_cornerRadius(rect: CGRect; cornerRadius: CGFloat): UIBezierPath; message 'bezierPathWithRoundedRect:cornerRadius:';
    class function bezierPathWithRoundedRect_byRoundingCorners_cornerRadii(rect: CGRect; corners: UIRectCorner; cornerRadii: CGSize): UIBezierPath; message 'bezierPathWithRoundedRect:byRoundingCorners:cornerRadii:';
    class function bezierPathWithArcCenter_radius_startAngle_endAngle_clockwise(center: CGPoint; radius: CGFloat; startAngle: CGFloat; endAngle: CGFloat; clockwise: Boolean): UIBezierPath; message 'bezierPathWithArcCenter:radius:startAngle:endAngle:clockwise:';
    class function bezierPathWithCGPath(CGPath: CGPathRef): UIBezierPath; message 'bezierPathWithCGPath:';
    procedure setCGPath (newValue: CGPathRef); message 'setCGPath:';
    function cGPath: CGPathRef; message 'cGPath';
    procedure moveToPoint(point: CGPoint); message 'moveToPoint:';
    procedure addLineToPoint(point: CGPoint); message 'addLineToPoint:';
    procedure addCurveToPoint_controlPoint1_controlPoint2(endPoint: CGPoint; controlPoint: CGPoint; controlPoint1: CGPoint); message 'addCurveToPoint:controlPoint1:controlPoint2:';
    procedure addQuadCurveToPoint_controlPoint(endPoint: CGPoint; controlPoint: CGPoint); message 'addQuadCurveToPoint:controlPoint:';
    procedure addArcWithCenter_radius_startAngle_endAngle_clockwise(center: CGPoint; radius: CGFloat; startAngle: CGFloat; endAngle: CGFloat; clockwise: Boolean); message 'addArcWithCenter:radius:startAngle:endAngle:clockwise:';
    procedure closePath; message 'closePath';
    procedure removeAllPoints; message 'removeAllPoints';
    procedure appendPath(bezierPath_: UIBezierPath); message 'appendPath:';
    procedure applyTransform(transform: CGAffineTransform); message 'applyTransform:';
    function isEmpty: Boolean; message 'isEmpty';
    function bounds: CGRect; message 'bounds';
    function currentPoint: CGPoint; message 'currentPoint';
    function containsPoint(point: CGPoint): Boolean; message 'containsPoint:';
    procedure setLineWidth (newValue: CGFloat); message 'setLineWidth:';
    function lineWidth: CGFloat; message 'lineWidth';
    procedure setLineCapStyle (newValue: CGLineCap); message 'setLineCapStyle:';
    function lineCapStyle: CGLineCap; message 'lineCapStyle';
    procedure setLineJoinStyle (newValue: CGLineJoin); message 'setLineJoinStyle:';
    function lineJoinStyle: CGLineJoin; message 'lineJoinStyle';
    procedure setMiterLimit (newValue: CGFloat); message 'setMiterLimit:';
    function miterLimit: CGFloat; message 'miterLimit';
    procedure setFlatness (newValue: CGFloat); message 'setFlatness:';
    function flatness: CGFloat; message 'flatness';
    procedure setUsesEvenOddFillRule (newValue: Boolean); message 'setUsesEvenOddFillRule:';
    function usesEvenOddFillRule: Boolean; message 'usesEvenOddFillRule';
    procedure setLineDash_count_phase(pattern: CGFloatPtr; count: NSInteger; phase: CGFloat); message 'setLineDash:count:phase:';
    procedure getLineDash_count_phase(pattern: CGFloatPtr; count: NSIntegerPtr; phase: CGFloatPtr); message 'getLineDash:count:phase:';
    procedure fill; message 'fill';
    procedure stroke; message 'stroke';
    procedure fillWithBlendMode_alpha(blendMode: CGBlendMode; alpha: CGFloat); message 'fillWithBlendMode:alpha:';
    procedure strokeWithBlendMode_alpha(blendMode: CGBlendMode; alpha: CGFloat); message 'strokeWithBlendMode:alpha:';
    procedure addClip; message 'addClip';

    { Adopted Protocols }
    function copyWithZone(zone_: NSZonePtr): id;
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{$endif}
{$endif}
