{ Parsed from Uikit.framework UIButton.h }

{$ifdef TYPES}
{$ifndef UIBUTTON_PAS_T}
{$define UIBUTTON_PAS_T}

{ Types }
type
  
  UIButtonType = culong;

{ Constants }

const
  UIButtonTypeCustom = 0;
  UIButtonTypeRoundedRect = 1;
  UIButtonTypeDetailDisclosure = 2;
  UIButtonTypeInfoLight = 3;
  UIButtonTypeInfoDark = 4;
  UIButtonTypeContactAdd = 5;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIBUTTON_PAS_R}
{$define UIBUTTON_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIBUTTON_PAS_F}
{$define UIBUTTON_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIBUTTON_PAS_S}
{$define UIBUTTON_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIButton = objcclass;
  UIButtonPointer = ^UIButton;
  UIButtonPtr = UIButtonPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIBUTTON_PAS_C}
{$define UIBUTTON_PAS_C}

{ UIButton }
  UIButton = objcclass external (UIControl, NSCodingProtocol)
  private
    _contentLookup: CFMutableDictionaryRef;
    _contentEdgeInsets: UIEdgeInsets;
    _titleEdgeInsets: UIEdgeInsets;
    _imageEdgeInsets: UIEdgeInsets;
    _backgroundView: UIImageView;
    _imageView: UIImageView;
    _titleView: UILabel;
    _initialized: Boolean;
    __buttonFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIButton0: cuint);
       1: (
        reversesTitleShadowWhenHighlighted: 0..1;
        adjustsImageWhenHighlighted: 0..1;
        adjustsImageWhenDisabled: 0..1;
        autosizeToFit: 0..1;
        disabledDimsImage: 0..1;
        showsTouchWhenHighlighted: 0..1;
        buttonType: 0..((1 shl 8)-1);
        shouldHandleScrollerMouseEvent: 0..1;
      );
      end;
    
  public
    class function buttonWithType(buttonType: UIButtonType): id; message 'buttonWithType:';
    procedure setContentEdgeInsets (newValue: UIEdgeInsets); message 'setContentEdgeInsets:';
    function contentEdgeInsets: UIEdgeInsets; message 'contentEdgeInsets';
    procedure setTitleEdgeInsets (newValue: UIEdgeInsets); message 'setTitleEdgeInsets:';
    function titleEdgeInsets: UIEdgeInsets; message 'titleEdgeInsets';
    procedure setReversesTitleShadowWhenHighlighted (newValue: Boolean); message 'setReversesTitleShadowWhenHighlighted:';
    function reversesTitleShadowWhenHighlighted: Boolean; message 'reversesTitleShadowWhenHighlighted';
    procedure setImageEdgeInsets (newValue: UIEdgeInsets); message 'setImageEdgeInsets:';
    function imageEdgeInsets: UIEdgeInsets; message 'imageEdgeInsets';
    procedure setAdjustsImageWhenHighlighted (newValue: Boolean); message 'setAdjustsImageWhenHighlighted:';
    function adjustsImageWhenHighlighted: Boolean; message 'adjustsImageWhenHighlighted';
    procedure setAdjustsImageWhenDisabled (newValue: Boolean); message 'setAdjustsImageWhenDisabled:';
    function adjustsImageWhenDisabled: Boolean; message 'adjustsImageWhenDisabled';
    procedure setShowsTouchWhenHighlighted (newValue: Boolean); message 'setShowsTouchWhenHighlighted:';
    function showsTouchWhenHighlighted: Boolean; message 'showsTouchWhenHighlighted';
    function buttonType: UIButtonType; message 'buttonType';
    procedure setTitle_forState(title: NSString; state_: UIControlState); message 'setTitle:forState:';
    procedure setTitleColor_forState(color: UIColor; state_: UIControlState); message 'setTitleColor:forState:';
    procedure setTitleShadowColor_forState(color: UIColor; state_: UIControlState); message 'setTitleShadowColor:forState:';
    procedure setImage_forState(image: UIImage; state_: UIControlState); message 'setImage:forState:';
    procedure setBackgroundImage_forState(image: UIImage; state_: UIControlState); message 'setBackgroundImage:forState:';
    function titleForState(state_: UIControlState): NSString; message 'titleForState:';
    function titleColorForState(state_: UIControlState): UIColor; message 'titleColorForState:';
    function titleShadowColorForState(state_: UIControlState): UIColor; message 'titleShadowColorForState:';
    function imageForState(state_: UIControlState): UIImage; message 'imageForState:';
    function backgroundImageForState(state_: UIControlState): UIImage; message 'backgroundImageForState:';
    function currentTitle: NSString; message 'currentTitle';
    function currentTitleColor: UIColor; message 'currentTitleColor';
    function currentTitleShadowColor: UIColor; message 'currentTitleShadowColor';
    function currentImage: UIImage; message 'currentImage';
    function currentBackgroundImage: UIImage; message 'currentBackgroundImage';
    function titleLabel: UILabel; message 'titleLabel';
    function imageView: UIImageView; message 'imageView';
    function backgroundRectForBounds(bounds_: CGRect): CGRect; message 'backgroundRectForBounds:';
    function contentRectForBounds(bounds_: CGRect): CGRect; message 'contentRectForBounds:';
    function titleRectForContentRect(contentRect: CGRect): CGRect; message 'titleRectForContentRect:';
    function imageRectForContentRect(contentRect: CGRect): CGRect; message 'imageRectForContentRect:';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{ UIButtonDeprecatedCategory }
  UIButtonDeprecatedCategory = objccategory external (UIButton)
    procedure setFont (newValue: UIFont); message 'setFont:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function font: UIFont; message 'font'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setLineBreakMode (newValue: UILineBreakMode); message 'setLineBreakMode:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function lineBreakMode: UILineBreakMode; message 'lineBreakMode'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setTitleShadowOffset (newValue: CGSize); message 'setTitleShadowOffset:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function titleShadowOffset: CGSize; message 'titleShadowOffset'; deprecated 'in __IPHONE_2_0 and later, in  and later';
  end;

{$endif}
{$endif}
