{ Parsed from Uikit.framework UIControl.h }

{$ifdef TYPES}
{$ifndef UICONTROL_PAS_T}
{$define UICONTROL_PAS_T}

{ Constants }

const
  UIControlEventTouchDown = 1 shl  0;
  UIControlEventTouchDownRepeat = 1 shl  1;
  UIControlEventTouchDragInside = 1 shl  2;
  UIControlEventTouchDragOutside = 1 shl  3;
  UIControlEventTouchDragEnter = 1 shl  4;
  UIControlEventTouchDragExit = 1 shl  5;
  UIControlEventTouchUpInside = 1 shl  6;
  UIControlEventTouchUpOutside = 1 shl  7;
  UIControlEventTouchCancel = 1 shl  8;
  UIControlEventValueChanged = 1 shl 12;
  UIControlEventEditingDidBegin = 1 shl 16;
  UIControlEventEditingChanged = 1 shl 17;
  UIControlEventEditingDidEnd = 1 shl 18;
  UIControlEventEditingDidEndOnExit = 1 shl 19;
  UIControlEventAllTouchEvents = $00000FFF;
  UIControlEventAllEditingEvents = $000F0000;
  UIControlEventApplicationReserved = $0F000000;
  UIControlEventSystemReserved = $F0000000;
  UIControlEventAllEvents = $FFFFFFFF;

const
  UIControlContentVerticalAlignmentCenter = 0;
  UIControlContentVerticalAlignmentTop = 1;
  UIControlContentVerticalAlignmentBottom = 2;
  UIControlContentVerticalAlignmentFill = 3;

const
  UIControlContentHorizontalAlignmentCenter = 0;
  UIControlContentHorizontalAlignmentLeft = 1;
  UIControlContentHorizontalAlignmentRight = 2;
  UIControlContentHorizontalAlignmentFill = 3;

const
  UIControlStateNormal = 0;
  UIControlStateHighlighted = 1 shl 0;
  UIControlStateDisabled = 1 shl 1;
  UIControlStateSelected = 1 shl 2;
  UIControlStateApplication = $00FF0000;
  UIControlStateReserved = $FF000000;

{ Types }
type
  UIControlEvents = NSUInteger;
  UIControlEventsPtr = ^UIControlEvents;
  UIControlState = NSUInteger;
  UIControlStatePtr = ^UIControlState;

{ Types }
type
  
  UIControlContentVerticalAlignment = culong;
  UIControlContentHorizontalAlignment = culong;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UICONTROL_PAS_R}
{$define UICONTROL_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UICONTROL_PAS_F}
{$define UICONTROL_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UICONTROL_PAS_S}
{$define UICONTROL_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIControl = objcclass;
  UIControlPointer = ^UIControl;
  UIControlPtr = UIControlPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UICONTROL_PAS_C}
{$define UICONTROL_PAS_C}

{ UIControl }
  UIControl = objcclass external (UIView)
  private
    _targetActions: NSMutableArray;
    _previousPoint: CGPoint;
    _downTime: CFAbsoluteTime;
    __controlFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIControl0: cuint);
       1: (
        disabled: 0..1;
        tracking: 0..1;
        touchInside: 0..1;
        touchDragged: 0..1;
        requiresDisplayOnTracking: 0..1;
        highlighted: 0..1;
        dontHighlightOnTouchDown: 0..1;
        delayActions: 0..1;
        allowActionsToQueue: 0..1;
        pendingUnhighlight: 0..1;
        selected: 0..1;
        verticalAlignment: 0..((1 shl 2)-1);
        horizontalAlignment: 0..((1 shl 2)-1);
      );
      end;
    
  public
    procedure setEnabled (newValue: Boolean); message 'setEnabled:';
    function isEnabled: Boolean; message 'isEnabled';
    procedure setSelected (newValue: Boolean); message 'setSelected:';
    function isSelected: Boolean; message 'isSelected';
    procedure setHighlighted (newValue: Boolean); message 'setHighlighted:';
    function isHighlighted: Boolean; message 'isHighlighted';
    procedure setContentVerticalAlignment (newValue: UIControlContentVerticalAlignment); message 'setContentVerticalAlignment:';
    function contentVerticalAlignment: UIControlContentVerticalAlignment; message 'contentVerticalAlignment';
    procedure setContentHorizontalAlignment (newValue: UIControlContentHorizontalAlignment); message 'setContentHorizontalAlignment:';
    function contentHorizontalAlignment: UIControlContentHorizontalAlignment; message 'contentHorizontalAlignment';
    function state: UIControlState; message 'state';
    function isTracking: Boolean; message 'isTracking';
    function isTouchInside: Boolean; message 'isTouchInside';
    function beginTrackingWithTouch_withEvent(touch: UITouch; event: UIEvent): Boolean; message 'beginTrackingWithTouch:withEvent:';
    function continueTrackingWithTouch_withEvent(touch: UITouch; event: UIEvent): Boolean; message 'continueTrackingWithTouch:withEvent:';
    procedure endTrackingWithTouch_withEvent(touch: UITouch; event: UIEvent); message 'endTrackingWithTouch:withEvent:';
    procedure cancelTrackingWithEvent(event: UIEvent); message 'cancelTrackingWithEvent:';
    procedure addTarget_action_forControlEvents(target: id; action: SEL; controlEvents: UIControlEvents); message 'addTarget:action:forControlEvents:';
    procedure removeTarget_action_forControlEvents(target: id; action: SEL; controlEvents: UIControlEvents); message 'removeTarget:action:forControlEvents:';
    function allTargets: NSSet; message 'allTargets';
    function allControlEvents: UIControlEvents; message 'allControlEvents';
    function actionsForTarget_forControlEvent(target: id; controlEvent: UIControlEvents): NSArray; message 'actionsForTarget:forControlEvent:';
    procedure sendAction_to_forEvent(action: SEL; target: id; event: UIEvent); message 'sendAction:to:forEvent:';
    procedure sendActionsForControlEvents(controlEvents: UIControlEvents); message 'sendActionsForControlEvents:';
  end;

{$endif}
{$endif}
