{ Parsed from Uikit.framework UIDevice.h }

{$ifdef TYPES}
{$ifndef UIDEVICE_PAS_T}
{$define UIDEVICE_PAS_T}

{ Types }
type
  
  UIDeviceOrientation = culong;
  UIDeviceBatteryState = culong;
  UIUserInterfaceIdiom = culong;

{ Constants }

const
  UIDeviceOrientationUnknown = 0;
  UIDeviceOrientationPortrait = 1;
  UIDeviceOrientationPortraitUpsideDown = 2;
  UIDeviceOrientationLandscapeLeft = 3;
  UIDeviceOrientationLandscapeRight = 4;
  UIDeviceOrientationFaceUp = 5;
  UIDeviceOrientationFaceDown = 6;

const
  UIDeviceBatteryStateUnknown = 0;
  UIDeviceBatteryStateUnplugged = 1;
  UIDeviceBatteryStateCharging = 2;
  UIDeviceBatteryStateFull = 3;

const
  UIUserInterfaceIdiomPhone = 0;
  UIUserInterfaceIdiomPad = 1;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIDEVICE_PAS_R}
{$define UIDEVICE_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIDEVICE_PAS_F}
{$define UIDEVICE_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIDEVICE_PAS_S}
{$define UIDEVICE_PAS_S}

{ External string constants }
var
  UIDeviceOrientationDidChangeNotification: NSString; cvar; external;
  UIDeviceBatteryStateDidChangeNotification: NSString; cvar; external;
  UIDeviceBatteryLevelDidChangeNotification: NSString; cvar; external;
  UIDeviceProximityStateDidChangeNotification: NSString; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UIInputViewAudioFeedbackProtocol = objcprotocol;
  UIDevice = objcclass;
  UIDevicePointer = ^UIDevice;
  UIDevicePtr = UIDevicePointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIDEVICE_PAS_C}
{$define UIDEVICE_PAS_C}

{ UIDevice }
  UIDevice = objcclass external (NSObject)
  private
    _numDeviceOrientationObservers: NSInteger;
    _batteryLevel: single;
    __deviceFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIDevice0: cuint);
       1: (
        batteryMonitoringEnabled: 0..1;
        proximityMonitoringEnabled: 0..1;
        orientation: 0..((1 shl 3)-1);
        batteryState: 0..((1 shl 2)-1);
        proximityState: 0..1;
      );
      end;
    
  public
    class function currentDevice: UIDevice; message 'currentDevice';
    function name: NSString; message 'name';
    function model: NSString; message 'model';
    function localizedModel: NSString; message 'localizedModel';
    function systemName: NSString; message 'systemName';
    function systemVersion: NSString; message 'systemVersion';
    function orientation: UIDeviceOrientation; message 'orientation';
    function uniqueIdentifier: NSString; message 'uniqueIdentifier';
    function isGeneratingDeviceOrientationNotifications: Boolean; message 'isGeneratingDeviceOrientationNotifications';
    procedure beginGeneratingDeviceOrientationNotifications; message 'beginGeneratingDeviceOrientationNotifications';
    procedure endGeneratingDeviceOrientationNotifications; message 'endGeneratingDeviceOrientationNotifications';
    procedure setBatteryMonitoringEnabled (newValue: Boolean); message 'setBatteryMonitoringEnabled:';
    function isBatteryMonitoringEnabled: Boolean; message 'isBatteryMonitoringEnabled';
    function batteryState: UIDeviceBatteryState; message 'batteryState';
    function batteryLevel: single; message 'batteryLevel';
    procedure setProximityMonitoringEnabled (newValue: Boolean); message 'setProximityMonitoringEnabled:';
    function isProximityMonitoringEnabled: Boolean; message 'isProximityMonitoringEnabled';
    function proximityState: Boolean; message 'proximityState';
    function isMultitaskingSupported: Boolean; message 'isMultitaskingSupported';
    function userInterfaceIdiom: UIUserInterfaceIdiom; message 'userInterfaceIdiom';
    procedure playInputClick; message 'playInputClick';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIDEVICE_PAS_P}
{$define UIDEVICE_PAS_P}
  
{ UIInputViewAudioFeedback Protocol }
  UIInputViewAudioFeedbackProtocol = objcprotocol external name 'UIInputViewAudioFeedback'
  optional
    function enableInputClicksWhenVisible: Boolean; message 'enableInputClicksWhenVisible';
  end;
{$endif}
{$endif}
