{ Parsed from Uikit.framework UIDocumentInteractionController.h }

{$ifdef TYPES}
{$ifndef UIDOCUMENTINTERACTIONCONTROLLER_PAS_T}
{$define UIDOCUMENTINTERACTIONCONTROLLER_PAS_T}

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIDOCUMENTINTERACTIONCONTROLLER_PAS_R}
{$define UIDOCUMENTINTERACTIONCONTROLLER_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIDOCUMENTINTERACTIONCONTROLLER_PAS_F}
{$define UIDOCUMENTINTERACTIONCONTROLLER_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIDOCUMENTINTERACTIONCONTROLLER_PAS_S}
{$define UIDOCUMENTINTERACTIONCONTROLLER_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIDocumentInteractionControllerDelegateProtocol = objcprotocol;
  UIDocumentInteractionController = objcclass;
  UIDocumentInteractionControllerPointer = ^UIDocumentInteractionController;
  UIDocumentInteractionControllerPtr = UIDocumentInteractionControllerPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIDOCUMENTINTERACTIONCONTROLLER_PAS_C}
{$define UIDOCUMENTINTERACTIONCONTROLLER_PAS_C}

{ UIDocumentInteractionController }
  UIDocumentInteractionController = objcclass external (NSObject, UIActionSheetDelegateProtocol)
  private
    _delegate: UIDocumentInteractionControllerDelegateProtocol;
    _previewItemProxy: id;
    _UTI: NSString;
    _icons: NSArray;
    _annotation: id;
    _uniqueIdentifier: NSString;
    _popoverController: UIPopoverController;
    _presentingViewController: UIViewController;
    _previewController: id;
    _gestureRecognizers: NSArray;
    _presentRect: CGRect;
    _presentView: UIView;
    _presentItem: UIBarButtonItem;
    _availableApplications: NSArray;
    _openInViewController: UIViewController;
    _optionsMenu: UIActionSheet;
    _openInMenu: UIActionSheet;
    _quickLookButtonIndex: NSInteger;
    _defaultOpenButtonIndex: NSInteger;
    _alternateOpenButtonIndex: NSInteger;
    _copyButtonIndex: NSInteger;
    _printButtonIndex: NSInteger;
    _openInTableViewSize: CGSize;
    _shouldUnzipDocument: Boolean;
    _unzippedDocumentURL: NSURL;
    _applicationToOpen: id;
    __documentInteractionControllerFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIDocumentInteractionController0: cuint);
       1: (
        delegateViewControllerForPreview: 0..1;
        delegateRectForPreview: 0..1;
        delegateViewForPreview: 0..1;
        transitionImageForPreview: 0..1;
        delegateWillBeginPreview: 0..1;
        delegateDidEndPreviewPreview: 0..1;
        delegateWillPresentOptionsMenu: 0..1;
        delegateDidDismissOptionsMenu: 0..1;
        delegateWillPresentOpenInMenu: 0..1;
        delegateDidDismissOpenInMenu: 0..1;
        delegateWillBeginSendingToApplication: 0..1;
        delegateDidEndSendingToApplication: 0..1;
        delegateCanPerformAction: 0..1;
        delegatePerformAction: 0..1;
        delegateUnzipURL: 0..1;
        delegateShouldRemoveUnzippedDocument: 0..1;
        delegateDidUnzipDocumentAtURL: 0..1;
      );
      end;
    
  public
    class function interactionControllerWithURL(url: NSURL): UIDocumentInteractionController; message 'interactionControllerWithURL:';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setURL (newValue: NSURL); message 'setURL:';
    function uRL: NSURL; message 'uRL';
    procedure setUTI (newValue: NSString); message 'setUTI:';
    function uTI: NSString; message 'uTI';
    procedure setName (newValue: NSString); message 'setName:';
    function name: NSString; message 'name';
    function icons: NSArray; message 'icons';
    procedure setAnnotation (newValue: id); message 'setAnnotation:';
    function annotation: id; message 'annotation';
    function presentOptionsMenuFromRect_inView_animated(rect: CGRect; view: UIView; animated: Boolean): Boolean; message 'presentOptionsMenuFromRect:inView:animated:';
    function presentOptionsMenuFromBarButtonItem_animated(item: UIBarButtonItem; animated: Boolean): Boolean; message 'presentOptionsMenuFromBarButtonItem:animated:';
    function presentPreviewAnimated(animated: Boolean): Boolean; message 'presentPreviewAnimated:';
    function presentOpenInMenuFromRect_inView_animated(rect: CGRect; view: UIView; animated: Boolean): Boolean; message 'presentOpenInMenuFromRect:inView:animated:';
    function presentOpenInMenuFromBarButtonItem_animated(item: UIBarButtonItem; animated: Boolean): Boolean; message 'presentOpenInMenuFromBarButtonItem:animated:';
    procedure dismissPreviewAnimated(animated: Boolean); message 'dismissPreviewAnimated:';
    procedure dismissMenuAnimated(animated: Boolean); message 'dismissMenuAnimated:';
    function gestureRecognizers: NSArray; message 'gestureRecognizers';

    { Adopted Protocols }
    procedure actionSheet_clickedButtonAtIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger);
    procedure actionSheetCancel(actionSheet: UIActionSheet);
    procedure willPresentActionSheet(actionSheet: UIActionSheet);
    procedure didPresentActionSheet(actionSheet: UIActionSheet);
    procedure actionSheet_willDismissWithButtonIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger);
    procedure actionSheet_didDismissWithButtonIndex(actionSheet: UIActionSheet; buttonIndex: NSInteger);
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIDOCUMENTINTERACTIONCONTROLLER_PAS_P}
{$define UIDOCUMENTINTERACTIONCONTROLLER_PAS_P}
  
{ UIDocumentInteractionControllerDelegate Protocol }
  UIDocumentInteractionControllerDelegateProtocol = objcprotocol external name 'UIDocumentInteractionControllerDelegate'
  optional
    function documentInteractionControllerViewControllerForPreview(controller: UIDocumentInteractionController): UIViewController; message 'documentInteractionControllerViewControllerForPreview:';
    function documentInteractionControllerRectForPreview(controller: UIDocumentInteractionController): CGRect; message 'documentInteractionControllerRectForPreview:';
    function documentInteractionControllerViewForPreview(controller: UIDocumentInteractionController): UIView; message 'documentInteractionControllerViewForPreview:';
    procedure documentInteractionControllerWillBeginPreview(controller: UIDocumentInteractionController); message 'documentInteractionControllerWillBeginPreview:';
    procedure documentInteractionControllerDidEndPreview(controller: UIDocumentInteractionController); message 'documentInteractionControllerDidEndPreview:';
    procedure documentInteractionControllerWillPresentOptionsMenu(controller: UIDocumentInteractionController); message 'documentInteractionControllerWillPresentOptionsMenu:';
    procedure documentInteractionControllerDidDismissOptionsMenu(controller: UIDocumentInteractionController); message 'documentInteractionControllerDidDismissOptionsMenu:';
    procedure documentInteractionControllerWillPresentOpenInMenu(controller: UIDocumentInteractionController); message 'documentInteractionControllerWillPresentOpenInMenu:';
    procedure documentInteractionControllerDidDismissOpenInMenu(controller: UIDocumentInteractionController); message 'documentInteractionControllerDidDismissOpenInMenu:';
    procedure documentInteractionController_willBeginSendingToApplication(controller: UIDocumentInteractionController; application: NSString); message 'documentInteractionController:willBeginSendingToApplication:';
    procedure documentInteractionController_didEndSendingToApplication(controller: UIDocumentInteractionController; application: NSString); message 'documentInteractionController:didEndSendingToApplication:';
    function documentInteractionController_canPerformAction(controller: UIDocumentInteractionController; action: SEL): Boolean; message 'documentInteractionController:canPerformAction:';
    function documentInteractionController_performAction(controller: UIDocumentInteractionController; action: SEL): Boolean; message 'documentInteractionController:performAction:';
  end;
{$endif}
{$endif}
