{ Parsed from Uikit.framework UIEvent.h }

{$ifdef TYPES}
{$ifndef UIEVENT_PAS_T}
{$define UIEVENT_PAS_T}

{ Types }
type
  
  UIEventType = culong;
  UIEventSubtype = culong;

{ Constants }

const
  UIEventTypeTouches = 0;
  UIEventTypeMotion = 1;
  UIEventTypeRemoteControl = 2;

const
  UIEventSubtypeNone = 0;
  UIEventSubtypeMotionShake = 1;
  UIEventSubtypeRemoteControlPlay = 100;
  UIEventSubtypeRemoteControlPause = 101;
  UIEventSubtypeRemoteControlStop = 102;
  UIEventSubtypeRemoteControlTogglePlayPause = 103;
  UIEventSubtypeRemoteControlNextTrack = 104;
  UIEventSubtypeRemoteControlPreviousTrack = 105;
  UIEventSubtypeRemoteControlBeginSeekingBackward = 106;
  UIEventSubtypeRemoteControlEndSeekingBackward = 107;
  UIEventSubtypeRemoteControlBeginSeekingForward = 108;
  UIEventSubtypeRemoteControlEndSeekingForward = 109;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIEVENT_PAS_R}
{$define UIEVENT_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIEVENT_PAS_F}
{$define UIEVENT_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIEVENT_PAS_S}
{$define UIEVENT_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIEvent = objcclass;
  UIEventPointer = ^UIEvent;
  UIEventPtr = UIEventPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIEVENT_PAS_C}
{$define UIEVENT_PAS_C}

{ UIEvent }
  UIEvent = objcclass external (NSObject)
  private
    _timestamp: NSTimeInterval;
    
  public
    function type_: UIEventType; message 'type_';
    function subtype: UIEventSubtype; message 'subtype';
    function timestamp: NSTimeInterval; message 'timestamp';
    function allTouches: NSSet; message 'allTouches';
    function touchesForWindow(window: UIWindow): NSSet; message 'touchesForWindow:';
    function touchesForView(view: UIView): NSSet; message 'touchesForView:';
    function touchesForGestureRecognizer(gesture: UIGestureRecognizer): NSSet; message 'touchesForGestureRecognizer:';
  end;

{$endif}
{$endif}
