{ Parsed from Uikit.framework UIGestureRecognizer.h }

{$ifdef TYPES}
{$ifndef UIGESTURERECOGNIZER_PAS_T}
{$define UIGESTURERECOGNIZER_PAS_T}

{ Types }
type
  
  UIGestureRecognizerState = culong;

{ Constants }

const
  UIGestureRecognizerStatePossible = 0;
  UIGestureRecognizerStateBegan = 1;
  UIGestureRecognizerStateChanged = 2;
  UIGestureRecognizerStateEnded = 3;
  UIGestureRecognizerStateCancelled = 4;
  UIGestureRecognizerStateFailed = 5;
  UIGestureRecognizerStateRecognized = UIGestureRecognizerStateEnded;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIGESTURERECOGNIZER_PAS_R}
{$define UIGESTURERECOGNIZER_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIGESTURERECOGNIZER_PAS_F}
{$define UIGESTURERECOGNIZER_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIGESTURERECOGNIZER_PAS_S}
{$define UIGESTURERECOGNIZER_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIGestureRecognizerDelegateProtocol = objcprotocol;
  UIGestureRecognizer = objcclass;
  UIGestureRecognizerPointer = ^UIGestureRecognizer;
  UIGestureRecognizerPtr = UIGestureRecognizerPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIGESTURERECOGNIZER_PAS_C}
{$define UIGESTURERECOGNIZER_PAS_C}

{ UIGestureRecognizer }
  UIGestureRecognizer = objcclass external (NSObject)
  private
    _targets: NSMutableArray;
    _delayedTouches: NSMutableArray;
    _view: UIView;
    _updateEvent: UIEvent;
    _delegate: UIGestureRecognizerDelegateProtocol;
    _failureRequirements: NSMutableSet;
    _failureDependents: NSMutableSet;
    _dynamicFailureRequirements: NSMutableSet;
    _dynamicFailureDependents: NSMutableSet;
    _unfailedGestures: NSMutableSet;
    _unfailedGesturesForReset: NSMutableSet;
    _friends: NSMutableSet;
    _state: UIGestureRecognizerState;
    __gestureFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIGestureRecognizer0: cuint);
       1: (
        delegateShouldBegin: 0..1;
        delegateCanPrevent: 0..1;
        delegateCanBePrevented: 0..1;
        delegateShouldRecognizeSimultaneously: 0..1;
        delegateShouldReceiveTouch: 0..1;
        delegateShouldRequireFailure: 0..1;
        delegateFailed: 0..1;
        privateDelegateShouldBegin: 0..1;
        privateDelegateShouldRecognizeSimultaneously: 0..1;
        privateDelegateShouldReceiveTouch: 0..1;
        subclassShouldRequireFailure: 0..1;
        cancelsTouchesInView: 0..1;
        delaysTouchesBegan: 0..1;
        delaysTouchesEnded: 0..1;
        notExclusive: 0..1;
        disabled: 0..1;
        dirty: 0..1;
        queriedFailureRequirements: 0..1;
        delivered: 0..1;
        continuous: 0..1;
        requiresDelayedBegan: 0..1;
      );
      end;
    
  public
    function initWithTarget_action(target: id; action: SEL): id; message 'initWithTarget:action:';
    procedure addTarget_action(target: id; action: SEL); message 'addTarget:action:';
    procedure removeTarget_action(target: id; action: SEL); message 'removeTarget:action:';
    function state: UIGestureRecognizerState; message 'state';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setEnabled (newValue: Boolean); message 'setEnabled:';
    function isEnabled: Boolean; message 'isEnabled';
    function view: UIView; message 'view';
    procedure setCancelsTouchesInView (newValue: Boolean); message 'setCancelsTouchesInView:';
    function cancelsTouchesInView: Boolean; message 'cancelsTouchesInView';
    procedure setDelaysTouchesBegan (newValue: Boolean); message 'setDelaysTouchesBegan:';
    function delaysTouchesBegan: Boolean; message 'delaysTouchesBegan';
    procedure setDelaysTouchesEnded (newValue: Boolean); message 'setDelaysTouchesEnded:';
    function delaysTouchesEnded: Boolean; message 'delaysTouchesEnded';
    procedure requireGestureRecognizerToFail(otherGestureRecognizer: UIGestureRecognizer); message 'requireGestureRecognizerToFail:';
    function locationInView(view_: UIView): CGPoint; message 'locationInView:';
    function numberOfTouches: NSUInteger; message 'numberOfTouches';
    function locationOfTouch_inView(touchIndex: NSUInteger; view_: UIView): CGPoint; message 'locationOfTouch:inView:';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIGESTURERECOGNIZER_PAS_P}
{$define UIGESTURERECOGNIZER_PAS_P}
  
{ UIGestureRecognizerDelegate Protocol }
  UIGestureRecognizerDelegateProtocol = objcprotocol external name 'UIGestureRecognizerDelegate'
  optional
    function gestureRecognizerShouldBegin(gestureRecognizer: UIGestureRecognizer): Boolean; message 'gestureRecognizerShouldBegin:';
    function gestureRecognizer_shouldRecognizeSimultaneouslyWithGestureRecognizer(gestureRecognizer: UIGestureRecognizer; otherGestureRecognizer: UIGestureRecognizer): Boolean; message 'gestureRecognizer:shouldRecognizeSimultaneouslyWithGestureRecognizer:';
    function gestureRecognizer_shouldReceiveTouch(gestureRecognizer: UIGestureRecognizer; touch: UITouch): Boolean; message 'gestureRecognizer:shouldReceiveTouch:';
  end;
{$endif}
{$endif}
