{ Parsed from Uikit.framework UIImage.h }

{$ifdef TYPES}
{$ifndef UIIMAGE_PAS_T}
{$define UIIMAGE_PAS_T}

{ Types }
type
  
  UIImageOrientation = culong;

{ Constants }

const
  UIImageOrientationUp = 0;
  UIImageOrientationDown = 1;
  UIImageOrientationLeft = 2;
  UIImageOrientationRight = 3;
  UIImageOrientationUpMirrored = 4;
  UIImageOrientationDownMirrored = 5;
  UIImageOrientationLeftMirrored = 6;
  UIImageOrientationRightMirrored = 7;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIIMAGE_PAS_R}
{$define UIIMAGE_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIIMAGE_PAS_F}
{$define UIIMAGE_PAS_F}

{ Functions }
function UIImagePNGRepresentation(image: UIImage): NSData; cdecl; external;
function UIImageJPEGRepresentation(image: UIImage; compressionQuality: CGFloat): NSData; cdecl; external;

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIIMAGE_PAS_S}
{$define UIIMAGE_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIImage = objcclass;
  UIImagePointer = ^UIImage;
  UIImagePtr = UIImagePointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIIMAGE_PAS_C}
{$define UIIMAGE_PAS_C}

{ UIImage }
  UIImage = objcclass external (NSObject)
  private
    _imageRef: CFTypeRef;
    _scale: CGFloat;
    __imageFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIImage0: cuint);
       1: (
        named: 0..1;
        imageOrientation: 0..((1 shl 3)-1);
        cached: 0..1;
        stretchable: 0..1;
        hasBeenCached: 0..1;
      );
      end;
    
  public
    class function imageNamed(name: NSString): UIImage; message 'imageNamed:';
    class function imageWithContentsOfFile(path: NSString): UIImage; message 'imageWithContentsOfFile:';
    class function imageWithData(data: NSData): UIImage; message 'imageWithData:';
    class function imageWithCGImage(imageRef: CGImageRef): UIImage; message 'imageWithCGImage:';
    class function imageWithCGImage_scale_orientation(imageRef: CGImageRef; scale: CGFloat; orientation: UIImageOrientation): UIImage; message 'imageWithCGImage:scale:orientation:';
    function initWithContentsOfFile(path: NSString): id; message 'initWithContentsOfFile:';
    function initWithData(data: NSData): id; message 'initWithData:';
    function initWithCGImage(imageRef: CGImageRef): id; message 'initWithCGImage:';
    function initWithCGImage_scale_orientation(imageRef: CGImageRef; scale: CGFloat; orientation: UIImageOrientation): id; message 'initWithCGImage:scale:orientation:';
    function size: CGSize; message 'size';
    function CGImage: CGImageRef; message 'CGImage';
    function imageOrientation: UIImageOrientation; message 'imageOrientation';
    function scale: CGFloat; message 'scale';
    procedure drawAtPoint(point: CGPoint); message 'drawAtPoint:';
    procedure drawAtPoint_blendMode_alpha(point: CGPoint; blendMode: CGBlendMode; alpha: CGFloat); message 'drawAtPoint:blendMode:alpha:';
    procedure drawInRect(rect: CGRect); message 'drawInRect:';
    procedure drawInRect_blendMode_alpha(rect: CGRect; blendMode: CGBlendMode; alpha: CGFloat); message 'drawInRect:blendMode:alpha:';
    procedure drawAsPatternInRect(rect: CGRect); message 'drawAsPatternInRect:';
    function stretchableImageWithLeftCapWidth_topCapHeight(leftCapWidth: NSInteger; topCapHeight: NSInteger): UIImage; message 'stretchableImageWithLeftCapWidth:topCapHeight:';
    function leftCapWidth: NSInteger; message 'leftCapWidth';
    function topCapHeight: NSInteger; message 'topCapHeight';
  end;

{$endif}
{$endif}
