{ Parsed from Uikit.framework UIImagePickerController.h }

{$ifdef TYPES}
{$ifndef UIIMAGEPICKERCONTROLLER_PAS_T}
{$define UIIMAGEPICKERCONTROLLER_PAS_T}

{ Constants }

const
  UIImagePickerControllerSourceTypePhotoLibrary = 0;
  UIImagePickerControllerSourceTypeCamera = 1;
  UIImagePickerControllerSourceTypeSavedPhotosAlbum = 2;

const
  UIImagePickerControllerQualityTypeHigh = 0;
  UIImagePickerControllerQualityType640x480 = 3;
  UIImagePickerControllerQualityTypeMedium = 1;
  UIImagePickerControllerQualityTypeLow = 2;

const
  UIImagePickerControllerCameraCaptureModePhoto = 0;
  UIImagePickerControllerCameraCaptureModeVideo = 1;

const
  UIImagePickerControllerCameraDeviceRear = 0;
  UIImagePickerControllerCameraDeviceFront = 1;

const
  UIImagePickerControllerCameraFlashModeOff = -1;
  UIImagePickerControllerCameraFlashModeAuto = 0;
  UIImagePickerControllerCameraFlashModeOn = 1;

{ Types }
type
  UIImagePickerControllerSourceType = NSUInteger;
  UIImagePickerControllerSourceTypePtr = ^UIImagePickerControllerSourceType;
  UIImagePickerControllerQualityType = NSUInteger;
  UIImagePickerControllerQualityTypePtr = ^UIImagePickerControllerQualityType;
  UIImagePickerControllerCameraCaptureMode = NSUInteger;
  UIImagePickerControllerCameraCaptureModePtr = ^UIImagePickerControllerCameraCaptureMode;
  UIImagePickerControllerCameraDevice = NSUInteger;
  UIImagePickerControllerCameraDevicePtr = ^UIImagePickerControllerCameraDevice;
  UIImagePickerControllerCameraFlashMode = NSInteger;
  UIImagePickerControllerCameraFlashModePtr = ^UIImagePickerControllerCameraFlashMode;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIIMAGEPICKERCONTROLLER_PAS_R}
{$define UIIMAGEPICKERCONTROLLER_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIIMAGEPICKERCONTROLLER_PAS_F}
{$define UIIMAGEPICKERCONTROLLER_PAS_F}

{ Functions }
procedure UIImageWriteToSavedPhotosAlbum(image: UIImage; completionTarget: id; completionSelector: SEL; contextInfo: Pointer); cdecl; external;
function UIVideoAtPathIsCompatibleWithSavedPhotosAlbum(videoPath: NSString): Boolean; cdecl; external;
procedure UISaveVideoAtPathToSavedPhotosAlbum(videoPath: NSString; completionTarget: id; completionSelector: SEL; contextInfo: Pointer); cdecl; external;

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIIMAGEPICKERCONTROLLER_PAS_S}
{$define UIIMAGEPICKERCONTROLLER_PAS_S}

{ External string constants }
var
  UIImagePickerControllerMediaType: NSString; cvar; external;
  UIImagePickerControllerOriginalImage: NSString; cvar; external;
  UIImagePickerControllerEditedImage: NSString; cvar; external;
  UIImagePickerControllerCropRect: NSString; cvar; external;
  UIImagePickerControllerMediaURL: NSString; cvar; external;
  UIImagePickerControllerReferenceURL: NSString; cvar; external;
  UIImagePickerControllerMediaMetadata: NSString; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UIImagePickerControllerDelegateProtocol = objcprotocol;
  UIImagePickerController = objcclass;
  UIImagePickerControllerPointer = ^UIImagePickerController;
  UIImagePickerControllerPtr = UIImagePickerControllerPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIIMAGEPICKERCONTROLLER_PAS_C}
{$define UIIMAGEPICKERCONTROLLER_PAS_C}

{ UIImagePickerController }
  UIImagePickerController = objcclass external (UINavigationController, NSCodingProtocol)
  private
    _sourceType: UIImagePickerControllerSourceType;
    _image: id;
    _cropRect: CGRect;
    _mediaTypes: NSArray;
    _properties: NSMutableDictionary;
    _previousStatusBarMode: cint;
    __imagePickerFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIImagePickerController0: cuint);
       1: (
        visible: 0..1;
        isCleaningUp: 0..1;
        savingOptions: 0..((1 shl 3)-1);
        didRevertStatusBar: 0..1;
      );
      end;
    
  public
    class function isSourceTypeAvailable(sourceType: UIImagePickerControllerSourceType): Boolean; message 'isSourceTypeAvailable:';
    class function availableMediaTypesForSourceType(sourceType: UIImagePickerControllerSourceType): NSArray; message 'availableMediaTypesForSourceType:';
    class function isCameraDeviceAvailable(cameraDevice: UIImagePickerControllerCameraDevice): Boolean; message 'isCameraDeviceAvailable:';
    class function isFlashAvailableForCameraDevice(cameraDevice: UIImagePickerControllerCameraDevice): Boolean; message 'isFlashAvailableForCameraDevice:';
    class function availableCaptureModesForCameraDevice(cameraDevice: UIImagePickerControllerCameraDevice): NSArray; message 'availableCaptureModesForCameraDevice:';
    procedure setUINavigationControllerDelegate (newValue: id); message 'setUINavigationControllerDelegate:';
    function uINavigationControllerDelegate: id; message 'uINavigationControllerDelegate';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setSourceType (newValue: UIImagePickerControllerSourceType); message 'setSourceType:';
    function sourceType: UIImagePickerControllerSourceType; message 'sourceType';
    procedure setMediaTypes (newValue: NSArray); message 'setMediaTypes:';
    function mediaTypes: NSArray; message 'mediaTypes';
    procedure setAllowsEditing (newValue: Boolean); message 'setAllowsEditing:';
    function allowsEditing: Boolean; message 'allowsEditing';
    procedure setAllowsImageEditing (newValue: Boolean); message 'setAllowsImageEditing:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function allowsImageEditing: Boolean; message 'allowsImageEditing'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setVideoMaximumDuration (newValue: NSTimeInterval); message 'setVideoMaximumDuration:';
    function videoMaximumDuration: NSTimeInterval; message 'videoMaximumDuration';
    procedure setVideoQuality (newValue: UIImagePickerControllerQualityType); message 'setVideoQuality:';
    function videoQuality: UIImagePickerControllerQualityType; message 'videoQuality';
    procedure setShowsCameraControls (newValue: Boolean); message 'setShowsCameraControls:';
    function showsCameraControls: Boolean; message 'showsCameraControls';
    procedure setCameraOverlayView (newValue: UIView); message 'setCameraOverlayView:';
    function cameraOverlayView: UIView; message 'cameraOverlayView';
    procedure setCameraViewTransform (newValue: CGAffineTransform); message 'setCameraViewTransform:';
    function cameraViewTransform: CGAffineTransform; message 'cameraViewTransform';
    procedure takePicture; message 'takePicture';
    function startVideoCapture: Boolean; message 'startVideoCapture';
    procedure stopVideoCapture; message 'stopVideoCapture';
    procedure setCameraCaptureMode (newValue: UIImagePickerControllerCameraCaptureMode); message 'setCameraCaptureMode:';
    function cameraCaptureMode: UIImagePickerControllerCameraCaptureMode; message 'cameraCaptureMode';
    procedure setCameraDevice (newValue: UIImagePickerControllerCameraDevice); message 'setCameraDevice:';
    function cameraDevice: UIImagePickerControllerCameraDevice; message 'cameraDevice';
    procedure setCameraFlashMode (newValue: UIImagePickerControllerCameraFlashMode); message 'setCameraFlashMode:';
    function cameraFlashMode: UIImagePickerControllerCameraFlashMode; message 'cameraFlashMode';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIIMAGEPICKERCONTROLLER_PAS_P}
{$define UIIMAGEPICKERCONTROLLER_PAS_P}
  
{ UIImagePickerControllerDelegate Protocol }
  UIImagePickerControllerDelegateProtocol = objcprotocol external name 'UIImagePickerControllerDelegate'
  optional
    procedure imagePickerController_didFinishPickingImage_editingInfo(picker: UIImagePickerController; image: UIImage; editingInfo: NSDictionary); message 'imagePickerController:didFinishPickingImage:editingInfo:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure imagePickerController_didFinishPickingMediaWithInfo(picker: UIImagePickerController; info: NSDictionary); message 'imagePickerController:didFinishPickingMediaWithInfo:';
    procedure imagePickerControllerDidCancel(picker: UIImagePickerController); message 'imagePickerControllerDidCancel:';
  end;
{$endif}
{$endif}
