{ Parsed from Uikit.framework UIMenuController.h }

{$ifdef TYPES}
{$ifndef UIMENUCONTROLLER_PAS_T}
{$define UIMENUCONTROLLER_PAS_T}

{ Types }
type
  
  UIMenuControllerArrowDirection = culong;

{ Constants }

const
  UIMenuControllerArrowDefault = 0;
  UIMenuControllerArrowUp = 1;
  UIMenuControllerArrowDown = 2;
  UIMenuControllerArrowLeft = 3;
  UIMenuControllerArrowRight = 4;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIMENUCONTROLLER_PAS_R}
{$define UIMENUCONTROLLER_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIMENUCONTROLLER_PAS_F}
{$define UIMENUCONTROLLER_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIMENUCONTROLLER_PAS_S}
{$define UIMENUCONTROLLER_PAS_S}

{ External string constants }
var
  UIMenuControllerWillShowMenuNotification: NSString; cvar; external;
  UIMenuControllerDidShowMenuNotification: NSString; cvar; external;
  UIMenuControllerWillHideMenuNotification: NSString; cvar; external;
  UIMenuControllerDidHideMenuNotification: NSString; cvar; external;
  UIMenuControllerMenuFrameDidChangeNotification: NSString; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UIMenuController = objcclass;
  UIMenuControllerPointer = ^UIMenuController;
  UIMenuControllerPtr = UIMenuControllerPointer;
  UIMenuItem = objcclass;
  UIMenuItemPointer = ^UIMenuItem;
  UIMenuItemPtr = UIMenuItemPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIMENUCONTROLLER_PAS_C}
{$define UIMENUCONTROLLER_PAS_C}

{ UIMenuController }
  UIMenuController = objcclass external (NSObject)
  private
    _targetRect: CGRect;
    _arrowDirection: UIMenuControllerArrowDirection;
    
  public
    class function sharedMenuController: UIMenuController; message 'sharedMenuController';
    procedure setMenuVisible (newValue: Boolean); message 'setMenuVisible:';
    function isMenuVisible: Boolean; message 'isMenuVisible';
    procedure setMenuVisible_animated(menuVisible: Boolean; animated: Boolean); message 'setMenuVisible:animated:';
    procedure setTargetRect_inView(targetRect: CGRect; targetView: UIView); message 'setTargetRect:inView:';
    procedure setArrowDirection (newValue: UIMenuControllerArrowDirection); message 'setArrowDirection:';
    function arrowDirection: UIMenuControllerArrowDirection; message 'arrowDirection';
    procedure setMenuItems (newValue: NSArray); message 'setMenuItems:';
    function menuItems: NSArray; message 'menuItems';
    procedure update; message 'update';
    function menuFrame: CGRect; message 'menuFrame';
  end;

{ UIMenuItem }
  UIMenuItem = objcclass external (NSObject)
  private
    _title: NSString;
    _action: SEL;
    
  public
    function initWithTitle_action(title: NSString; action: SEL): id; message 'initWithTitle:action:';
    procedure setTitle (newValue: NSString); message 'setTitle:';
    function title: NSString; message 'title';
    procedure setAction (newValue: SEL); message 'setAction:';
    function action: SEL; message 'action';
  end;

{$endif}
{$endif}
