{ Parsed from Uikit.framework UINavigationBar.h }

{$ifdef TYPES}
{$ifndef UINAVIGATIONBAR_PAS_T}
{$define UINAVIGATIONBAR_PAS_T}

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UINAVIGATIONBAR_PAS_R}
{$define UINAVIGATIONBAR_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UINAVIGATIONBAR_PAS_F}
{$define UINAVIGATIONBAR_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UINAVIGATIONBAR_PAS_S}
{$define UINAVIGATIONBAR_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UINavigationBarDelegateProtocol = objcprotocol;
  UINavigationBar = objcclass;
  UINavigationBarPointer = ^UINavigationBar;
  UINavigationBarPtr = UINavigationBarPointer;
  UINavigationItem = objcclass;
  UINavigationItemPointer = ^UINavigationItem;
  UINavigationItemPtr = UINavigationItemPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UINAVIGATIONBAR_PAS_C}
{$define UINAVIGATIONBAR_PAS_C}

{ UINavigationBar }
  UINavigationBar = objcclass external (UIView, NSCodingProtocol)
  private
    _itemStack: NSMutableArray;
    _rightMargin: CGFloat;
    _state: cuint;
    _delegate: id;
    _titleView: UIView;
    _leftView: UIView;
    _rightView: UIView;
    _prompt: UIView;
    _accessoryView: UIView;
    _tintColor: UIColor;
    _appearance: id;
    __navbarFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UINavigationBar0: cuint);
       1: (
        animate: 0..1;
        animationDisabledCount: 0..((1 shl 10)-1);
        transitioningBarStyle: 0..1;
        newBarStyle: 0..((1 shl 3)-1);
        barStyle: 0..((1 shl 3)-1);
        isTranslucent: 0..1;
        disableLayout: 0..1;
        backPressed: 0..1;
        animatePromptChange: 0..1;
        pendingHideBackButton: 0..1;
        titleAutosizesToFit: 0..1;
        usingNewAPI: 0..1;
        minibar: 0..1;
        forceFullHeightInLandscape: 0..1;
        isLocked: 0..1;
        shouldUpdatePromptAfterTransition: 0..1;
        crossfadeItems: 0..1;
        autoAdjustTitle: 0..1;
        disableCustomTint: 0..1;
      );
      end;
    
  public
    procedure setBarStyle (newValue: UIBarStyle); message 'setBarStyle:';
    function barStyle: UIBarStyle; message 'barStyle';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setTintColor (newValue: UIColor); message 'setTintColor:';
    function tintColor: UIColor; message 'tintColor';
    procedure setTranslucent (newValue: Boolean); message 'setTranslucent:';
    function isTranslucent: Boolean; message 'isTranslucent';
    procedure pushNavigationItem_animated(item: UINavigationItem; animated: Boolean); message 'pushNavigationItem:animated:';
    function popNavigationItemAnimated(animated: Boolean): UINavigationItem; message 'popNavigationItemAnimated:';
    function topItem: UINavigationItem; message 'topItem';
    function backItem: UINavigationItem; message 'backItem';
    procedure setItems (newValue: NSArray); message 'setItems:';
    function items: NSArray; message 'items';
    procedure setItems_animated(items_: NSArray; animated: Boolean); message 'setItems:animated:';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{ UINavigationItem }
  UINavigationItem = objcclass external (NSObject, NSCodingProtocol)
  private
    _title: NSString;
    _backButtonTitle: NSString;
    _backBarButtonItem: UIBarButtonItem;
    _prompt: NSString;
    _tag: NSInteger;
    _context: id;
    _navigationBar: UINavigationBar;
    _defaultTitleView: UIView;
    _titleView: UIView;
    _backButtonView: UIView;
    _leftBarButtonItem: UIBarButtonItem;
    _rightBarButtonItem: UIBarButtonItem;
    _customLeftView: UIView;
    _customRightView: UIView;
    _hidesBackButton: Boolean;
    _frozenTitleView: UIImageView;
    
  public
    function initWithTitle(title: NSString): id; message 'initWithTitle:';
    procedure setTitle (newValue: NSString); message 'setTitle:';
    function title: NSString; message 'title';
    procedure setBackBarButtonItem (newValue: UIBarButtonItem); message 'setBackBarButtonItem:';
    function backBarButtonItem: UIBarButtonItem; message 'backBarButtonItem';
    procedure setTitleView (newValue: UIView); message 'setTitleView:';
    function titleView: UIView; message 'titleView';
    procedure setPrompt (newValue: NSString); message 'setPrompt:';
    function prompt: NSString; message 'prompt';
    procedure setHidesBackButton (newValue: Boolean); message 'setHidesBackButton:';
    function hidesBackButton: Boolean; message 'hidesBackButton';
    procedure setHidesBackButton_animated(hidesBackButton_: Boolean; animated: Boolean); message 'setHidesBackButton:animated:';
    procedure setLeftBarButtonItem (newValue: UIBarButtonItem); message 'setLeftBarButtonItem:';
    function leftBarButtonItem: UIBarButtonItem; message 'leftBarButtonItem';
    procedure setRightBarButtonItem (newValue: UIBarButtonItem); message 'setRightBarButtonItem:';
    function rightBarButtonItem: UIBarButtonItem; message 'rightBarButtonItem';
    procedure setLeftBarButtonItem_animated(item: UIBarButtonItem; animated: Boolean); message 'setLeftBarButtonItem:animated:';
    procedure setRightBarButtonItem_animated(item: UIBarButtonItem; animated: Boolean); message 'setRightBarButtonItem:animated:';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UINAVIGATIONBAR_PAS_P}
{$define UINAVIGATIONBAR_PAS_P}
  
{ UINavigationBarDelegate Protocol }
  UINavigationBarDelegateProtocol = objcprotocol external name 'UINavigationBarDelegate'
  optional
    function navigationBar_shouldPushItem(navigationBar: UINavigationBar; item: UINavigationItem): Boolean; message 'navigationBar:shouldPushItem:';
    procedure navigationBar_didPushItem(navigationBar: UINavigationBar; item: UINavigationItem); message 'navigationBar:didPushItem:';
    function navigationBar_shouldPopItem(navigationBar: UINavigationBar; item: UINavigationItem): Boolean; message 'navigationBar:shouldPopItem:';
    procedure navigationBar_didPopItem(navigationBar: UINavigationBar; item: UINavigationItem); message 'navigationBar:didPopItem:';
  end;
{$endif}
{$endif}
