{ Parsed from Uikit.framework UIPopoverController.h }

{$ifdef TYPES}
{$ifndef UIPOPOVERCONTROLLER_PAS_T}
{$define UIPOPOVERCONTROLLER_PAS_T}

{ Constants }

const
  UIPopoverArrowDirectionUp = 1 shl 0;
  UIPopoverArrowDirectionDown = 1 shl 1;
  UIPopoverArrowDirectionLeft = 1 shl 2;
  UIPopoverArrowDirectionRight = 1 shl 3;
  UIPopoverArrowDirectionUnknown = NSUIntegerMax;

{ Types }
type
  UIPopoverArrowDirection = NSUInteger;
  UIPopoverArrowDirectionPtr = ^UIPopoverArrowDirection;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIPOPOVERCONTROLLER_PAS_R}
{$define UIPOPOVERCONTROLLER_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIPOPOVERCONTROLLER_PAS_F}
{$define UIPOPOVERCONTROLLER_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIPOPOVERCONTROLLER_PAS_S}
{$define UIPOPOVERCONTROLLER_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIPopoverControllerDelegateProtocol = objcprotocol;
  UIPopoverController = objcclass;
  UIPopoverControllerPointer = ^UIPopoverController;
  UIPopoverControllerPtr = UIPopoverControllerPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIPOPOVERCONTROLLER_PAS_C}
{$define UIPOPOVERCONTROLLER_PAS_C}

{ UIPopoverController }
  UIPopoverController = objcclass external (NSObject)
  private
    _delegate: id;
    _contentViewController: UIViewController;
    _popoverView: UIView;
    _private1: id;
    _passthroughViews: NSArray;
    _popoverArrowDirection: UIPopoverArrowDirection;
    _popoverBackgroundStyle: NSUInteger;
    _popoverContentSize: CGSize;
    _targetBarButtonItem: UIBarButtonItem;
    _toViewAutoResizingMask: UIViewAutoresizing;
    _modalPresentationFromViewController: UIViewController;
    _modalPresentationToViewController: UIViewController;
    _slidingViewController: UIViewController;
    _target: id;
    _didEndSelector: SEL;
    _existingNavBarStyle: UIBarStyle;
    _existingToolBarStyle: UIBarStyle;
    __popoverControllerFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIPopoverController0: cuint);
       1: (
        isPresentingOrDismissing: 0..1;
        isPresentingModalViewController: 0..1;
        isPresentingActionSheet: 0..1;
        needsRepresentAfterRotation: 0..1;
        dimsWhenModal: 0..1;
      );
      end;
    
  public
    function initWithContentViewController(viewController: UIViewController): id; message 'initWithContentViewController:';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setContentViewController (newValue: UIViewController); message 'setContentViewController:';
    function contentViewController: UIViewController; message 'contentViewController';
    procedure setContentViewController_animated(viewController: UIViewController; animated: Boolean); message 'setContentViewController:animated:';
    procedure setPopoverContentSize (newValue: CGSize); message 'setPopoverContentSize:';
    function popoverContentSize: CGSize; message 'popoverContentSize';
    procedure setPopoverContentSize_animated(size: CGSize; animated: Boolean); message 'setPopoverContentSize:animated:';
    function isPopoverVisible: Boolean; message 'isPopoverVisible';
    function popoverArrowDirection: UIPopoverArrowDirection; message 'popoverArrowDirection';
    procedure setPassthroughViews (newValue: NSArray); message 'setPassthroughViews:';
    function passthroughViews: NSArray; message 'passthroughViews';
    procedure presentPopoverFromRect_inView_permittedArrowDirections_animated(rect: CGRect; view: UIView; arrowDirections: UIPopoverArrowDirection; animated: Boolean); message 'presentPopoverFromRect:inView:permittedArrowDirections:animated:';
    procedure presentPopoverFromBarButtonItem_permittedArrowDirections_animated(item: UIBarButtonItem; arrowDirections: UIPopoverArrowDirection; animated: Boolean); message 'presentPopoverFromBarButtonItem:permittedArrowDirections:animated:';
    procedure dismissPopoverAnimated(animated: Boolean); message 'dismissPopoverAnimated:';
  end;

{ UIPopoverController_UIViewControllerCategory }
  UIPopoverController_UIViewControllerCategory = objccategory external name 'UIPopoverController' (UIViewController)
    procedure setContentSizeForViewInPopover (newValue: CGSize); message 'setContentSizeForViewInPopover:';
    function contentSizeForViewInPopover: CGSize; message 'contentSizeForViewInPopover';
    procedure setModalInPopover (newValue: Boolean); message 'setModalInPopover:';
    function isModalInPopover: Boolean; message 'isModalInPopover';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIPOPOVERCONTROLLER_PAS_P}
{$define UIPOPOVERCONTROLLER_PAS_P}
  
{ UIPopoverControllerDelegate Protocol }
  UIPopoverControllerDelegateProtocol = objcprotocol external name 'UIPopoverControllerDelegate'
  optional
    function popoverControllerShouldDismissPopover(popoverController: UIPopoverController): Boolean; message 'popoverControllerShouldDismissPopover:';
    procedure popoverControllerDidDismissPopover(popoverController: UIPopoverController); message 'popoverControllerDidDismissPopover:';
  end;
{$endif}
{$endif}
