{ Parsed from Uikit.framework UIScrollView.h }

{$ifdef TYPES}
{$ifndef UISCROLLVIEW_PAS_T}
{$define UISCROLLVIEW_PAS_T}

{ Types }
type
  
  UIScrollViewIndicatorStyle = culong;

{ Constants }

const
  UIScrollViewIndicatorStyleDefault = 0;
  UIScrollViewIndicatorStyleBlack = 1;
  UIScrollViewIndicatorStyleWhite = 2;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UISCROLLVIEW_PAS_R}
{$define UISCROLLVIEW_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UISCROLLVIEW_PAS_F}
{$define UISCROLLVIEW_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UISCROLLVIEW_PAS_S}
{$define UISCROLLVIEW_PAS_S}

{ External symbols }
var
  UIScrollViewDecelerationRateNormal: single; cvar; external;
  UIScrollViewDecelerationRateFast: single; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UIScrollViewDelegateProtocol = objcprotocol;
  UIScrollView = objcclass;
  UIScrollViewPointer = ^UIScrollView;
  UIScrollViewPtr = UIScrollViewPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UISCROLLVIEW_PAS_C}
{$define UISCROLLVIEW_PAS_C}

{ UIScrollView }
  UIScrollView = objcclass external (UIView, NSCodingProtocol)
  private
    _contentSize: CGSize;
    _contentInset: UIEdgeInsets;
    _delegate: id;
    _verticalScrollIndicator: UIImageView;
    _horizontalScrollIndicator: UIImageView;
    _scrollIndicatorInset: UIEdgeInsets;
    __scrollViewFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIScrollView0: cuint);
       1: (
        tracking: 0..1;
        dragging: 0..1;
        verticalBounceEnabled: 0..1;
        horizontalBounceEnabled: 0..1;
        verticalBouncing: 0..1;
        horizontalBouncing: 0..1;
        bouncesZoom: 0..1;
        zoomBouncing: 0..1;
        alwaysBounceHorizontal: 0..1;
        alwaysBounceVertical: 0..1;
        canCancelContentTouches: 0..1;
        delaysContentTouches: 0..1;
        programmaticScrollDisabled: 0..1;
        scrollDisabled: 0..1;
        zoomDisabled: 0..1;
        scrollTriggered: 0..1;
        scrollDisabledOnTouchBegan: 0..1;
        ignoreNextTouchesMoved: 0..1;
        cancelNextContentTouchEnded: 0..1;
        inContentViewCall: 0..1;
        dontSelect: 0..1;
        contentTouched: 0..1;
        cantCancel: 0..1;
        directionalLockEnabled: cuint;
        directionalLockAutoEnabled: 0..1;
        lockVertical: 0..1;
        lockHorizontal: 0..1;
        keepLocked: cuint;
        showsHorizontalScrollIndicator: 0..1;
        showsVerticalScrollIndicator: 0..1;
        indicatorStyle: 0..((1 shl 2)-1);
        inZoom: 0..1;
        hideIndicatorsInZoom: 0..1;
        pushedTrackingMode: 0..1;
        multipleDrag: 0..1;
        displayingScrollIndicators: 0..1;
        verticalIndicatorShrunk: 0..1;
        horizontalIndicatorShrunk: 0..1;
        contentFitDisableScrolling: 0..1;
        pagingEnabled: 0..1;
        pagingLeft: 0..1;
        pagingRight: 0..1;
        pagingUp: 0..1;
        pagingDown: 0..1;
        lastHorizontalDirection: 0..1;
        lastVerticalDirection: 0..1;
        dontScrollToTop: 0..1;
        scrollingToTop: 0..1;
        useGestureRecognizers: 0..1;
        autoscrolling: 0..1;
        automaticContentOffsetAdjustmentDisabled: 0..1;
        skipStartOffsetAdjustment: 0..1;
        delegateScrollViewDidScroll: 0..1;
        delegateScrollViewDidZoom: 0..1;
        delegateContentSizeForZoomScale: 0..1;
        preserveCenterDuringRotation: 0..1;
        delaysTrackingWhileDecelerating: 0..1;
        pinnedZoomMin: 0..1;
        pinnedXMin: 0..1;
        pinnedYMin: 0..1;
        pinnedXMax: 0..1;
        pinnedYMax: 0..1;
        skipLinkChecks: 0..1;
        wasIgnoringTapsInDimmingView: 0..1;
        isAnimatingScroll: 0..1;
        isAnimatingZoom: 0..1;
        staysCenteredDuringPinch: 0..1;
      );
      end;
    _farthestDistance: CGFloat;
    _initialTouchPosition: CGPoint;
    _startTouchPosition: CGPoint;
    _startTouchTime: CFTimeInterval;
    _startOffsetX: double;
    _startOffsetY: double;
    _lastUpdateOffsetX: double;
    _lastUpdateOffsetY: double;
    _lastTouchPosition: CGPoint;
    _lastTouchTime: CFTimeInterval;
    _lastUpdateTime: CFTimeInterval;
    _zoomAnchorPoint: CGPoint;
    _contentView: UIView;
    _minimumZoomScale: single;
    _maximumZoomScale: single;
    _zoomRubberBandHysteresisCount: cint;
    _zoomView: UIView;
    _horizontalVelocity: double;
    _verticalVelocity: double;
    _previousHorizontalVelocity: double;
    _previousVerticalVelocity: double;
    _stopOffset: CGPoint;
    _scrollHeartbeat: CFTypeRef;
    _pageDecelerationTarget: CGPoint;
    _decelerationFactor: CGSize;
    _decelerationLnFactorH: double;
    _decelerationLnFactorV: double;
    _deferredBeginTouchesInfo: NSArray;
    _shadows: UIImageViewPointer;
    _scrollNotificationViews: id;
    _contentOffsetAnimationDuration: CFTimeInterval;
    _animation: id;
    _pinch: id;
    _pan: id;
    _swipe: id;
    _pagingSpringPull: CGFloat;
    _pagingFriction: CGFloat;
    _fastScrollCount: NSInteger;
    _fastScrollMultiplier: CGFloat;
    _fastScrollStartMultiplier: CGFloat;
    _fastScrollEndTime: CFTimeInterval;
    _parentAdjustment: CGPoint;
    _rotationCenterPoint: CGPoint;
    _accuracy: CGFloat;
    _hysteresis: CGFloat;
    _zoomAnimationCount: NSUInteger;
    
  public
    procedure setContentOffset (newValue: CGPoint); message 'setContentOffset:';
    function contentOffset: CGPoint; message 'contentOffset';
    procedure setContentSize (newValue: CGSize); message 'setContentSize:';
    function contentSize: CGSize; message 'contentSize';
    procedure setContentInset (newValue: UIEdgeInsets); message 'setContentInset:';
    function contentInset: UIEdgeInsets; message 'contentInset';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setDirectionalLockEnabled (newValue: Boolean); message 'setDirectionalLockEnabled:';
    function isDirectionalLockEnabled: Boolean; message 'isDirectionalLockEnabled';
    procedure setBounces (newValue: Boolean); message 'setBounces:';
    function bounces: Boolean; message 'bounces';
    procedure setAlwaysBounceVertical (newValue: Boolean); message 'setAlwaysBounceVertical:';
    function alwaysBounceVertical: Boolean; message 'alwaysBounceVertical';
    procedure setAlwaysBounceHorizontal (newValue: Boolean); message 'setAlwaysBounceHorizontal:';
    function alwaysBounceHorizontal: Boolean; message 'alwaysBounceHorizontal';
    procedure setPagingEnabled (newValue: Boolean); message 'setPagingEnabled:';
    function isPagingEnabled: Boolean; message 'isPagingEnabled';
    procedure setScrollEnabled (newValue: Boolean); message 'setScrollEnabled:';
    function isScrollEnabled: Boolean; message 'isScrollEnabled';
    procedure setShowsHorizontalScrollIndicator (newValue: Boolean); message 'setShowsHorizontalScrollIndicator:';
    function showsHorizontalScrollIndicator: Boolean; message 'showsHorizontalScrollIndicator';
    procedure setShowsVerticalScrollIndicator (newValue: Boolean); message 'setShowsVerticalScrollIndicator:';
    function showsVerticalScrollIndicator: Boolean; message 'showsVerticalScrollIndicator';
    procedure setScrollIndicatorInsets (newValue: UIEdgeInsets); message 'setScrollIndicatorInsets:';
    function scrollIndicatorInsets: UIEdgeInsets; message 'scrollIndicatorInsets';
    procedure setIndicatorStyle (newValue: UIScrollViewIndicatorStyle); message 'setIndicatorStyle:';
    function indicatorStyle: UIScrollViewIndicatorStyle; message 'indicatorStyle';
    procedure setDecelerationRate (newValue: single); message 'setDecelerationRate:';
    function decelerationRate: single; message 'decelerationRate';
    procedure setContentOffset_animated(contentOffset_: CGPoint; animated: Boolean); message 'setContentOffset:animated:';
    procedure scrollRectToVisible_animated(rect: CGRect; animated: Boolean); message 'scrollRectToVisible:animated:';
    procedure flashScrollIndicators; message 'flashScrollIndicators';
    function isTracking: Boolean; message 'isTracking';
    function isDragging: Boolean; message 'isDragging';
    function isDecelerating: Boolean; message 'isDecelerating';
    procedure setDelaysContentTouches (newValue: Boolean); message 'setDelaysContentTouches:';
    function delaysContentTouches: Boolean; message 'delaysContentTouches';
    procedure setCanCancelContentTouches (newValue: Boolean); message 'setCanCancelContentTouches:';
    function canCancelContentTouches: Boolean; message 'canCancelContentTouches';
    function touchesShouldBegin_withEvent_inContentView(touches: NSSet; event: UIEvent; view: UIView): Boolean; message 'touchesShouldBegin:withEvent:inContentView:';
    function touchesShouldCancelInContentView(view: UIView): Boolean; message 'touchesShouldCancelInContentView:';
    procedure setMinimumZoomScale (newValue: single); message 'setMinimumZoomScale:';
    function minimumZoomScale: single; message 'minimumZoomScale';
    procedure setMaximumZoomScale (newValue: single); message 'setMaximumZoomScale:';
    function maximumZoomScale: single; message 'maximumZoomScale';
    procedure setZoomScale (newValue: single); message 'setZoomScale:';
    function zoomScale: single; message 'zoomScale';
    procedure setZoomScale_animated(scale: single; animated: Boolean); message 'setZoomScale:animated:';
    procedure zoomToRect_animated(rect: CGRect; animated: Boolean); message 'zoomToRect:animated:';
    procedure setBouncesZoom (newValue: Boolean); message 'setBouncesZoom:';
    function bouncesZoom: Boolean; message 'bouncesZoom';
    function isZooming: Boolean; message 'isZooming';
    function isZoomBouncing: Boolean; message 'isZoomBouncing';
    procedure setScrollsToTop (newValue: Boolean); message 'setScrollsToTop:';
    function scrollsToTop: Boolean; message 'scrollsToTop';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UISCROLLVIEW_PAS_P}
{$define UISCROLLVIEW_PAS_P}
  
{ UIScrollViewDelegate Protocol }
  UIScrollViewDelegateProtocol = objcprotocol external name 'UIScrollViewDelegate'
  optional
    procedure scrollViewDidScroll(scrollView: UIScrollView); message 'scrollViewDidScroll:';
    procedure scrollViewDidZoom(scrollView: UIScrollView); message 'scrollViewDidZoom:';
    procedure scrollViewWillBeginDragging(scrollView: UIScrollView); message 'scrollViewWillBeginDragging:';
    procedure scrollViewDidEndDragging_willDecelerate(scrollView: UIScrollView; decelerate: Boolean); message 'scrollViewDidEndDragging:willDecelerate:';
    procedure scrollViewWillBeginDecelerating(scrollView: UIScrollView); message 'scrollViewWillBeginDecelerating:';
    procedure scrollViewDidEndDecelerating(scrollView: UIScrollView); message 'scrollViewDidEndDecelerating:';
    procedure scrollViewDidEndScrollingAnimation(scrollView: UIScrollView); message 'scrollViewDidEndScrollingAnimation:';
    function viewForZoomingInScrollView(scrollView: UIScrollView): UIView; message 'viewForZoomingInScrollView:';
    procedure scrollViewWillBeginZooming_withView(scrollView: UIScrollView; view: UIView); message 'scrollViewWillBeginZooming:withView:';
    procedure scrollViewDidEndZooming_withView_atScale(scrollView: UIScrollView; view: UIView; scale: single); message 'scrollViewDidEndZooming:withView:atScale:';
    function scrollViewShouldScrollToTop(scrollView: UIScrollView): Boolean; message 'scrollViewShouldScrollToTop:';
    procedure scrollViewDidScrollToTop(scrollView: UIScrollView); message 'scrollViewDidScrollToTop:';
  end;
{$endif}
{$endif}
