{ Parsed from Uikit.framework UISegmentedControl.h }

{$ifdef TYPES}
{$ifndef UISEGMENTEDCONTROL_PAS_T}
{$define UISEGMENTEDCONTROL_PAS_T}

{ Types }
type
  
  UISegmentedControlStyle = culong;

{ Constants }

const
  UISegmentedControlStylePlain = 0;
  UISegmentedControlStyleBordered = 1;
  UISegmentedControlStyleBar = 2;
  UISegmentedControlStyleBezeled = 3;

const
  UISegmentedControlNoSegment = -1;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UISEGMENTEDCONTROL_PAS_R}
{$define UISEGMENTEDCONTROL_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UISEGMENTEDCONTROL_PAS_F}
{$define UISEGMENTEDCONTROL_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UISEGMENTEDCONTROL_PAS_S}
{$define UISEGMENTEDCONTROL_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UISegmentedControl = objcclass;
  UISegmentedControlPointer = ^UISegmentedControl;
  UISegmentedControlPtr = UISegmentedControlPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UISEGMENTEDCONTROL_PAS_C}
{$define UISEGMENTEDCONTROL_PAS_C}

{ UISegmentedControl }
  UISegmentedControl = objcclass external (UIControl, NSCodingProtocol)
  private
    _segments: NSMutableArray;
    _selectedSegment: NSInteger;
    _highlightedSegment: NSInteger;
    _removedSegment: UIView;
    _delegate: id;
    _tintColor: UIColor;
    _barStyle: UIBarStyle;
    _appearance: Pointer;
    __segmentedControlFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UISegmentedControl0: cuint);
       1: (
        style: 0..((1 shl 3)-1);
        size: 0..((1 shl 2)-1);
        showsDisclosure: 0..1;
        delegateSelectedSegmentChanged: 0..1;
        delegateDisclosureButtonClicked: 0..1;
        delegateAlwaysNotifiesDelegateOfSegmentClicks: 0..1;
        momentaryClick: 0..1;
        dontAlwaysToggleForTwoSegments: 0..1;
        tracking: 0..1;
        mouseInside: 0..1;
        autosizeToFitSegments: 0..1;
        isSizingToFit: 0..1;
        autosizeText: 0..1;
        transparentBackground: 0..1;
      );
      end;
    
  public
    function initWithItems(items: NSArray): id; message 'initWithItems:';
    procedure setSegmentedControlStyle (newValue: UISegmentedControlStyle); message 'setSegmentedControlStyle:';
    function segmentedControlStyle: UISegmentedControlStyle; message 'segmentedControlStyle';
    procedure setMomentary (newValue: Boolean); message 'setMomentary:';
    function isMomentary: Boolean; message 'isMomentary';
    procedure setTintColor (newValue: UIColor); message 'setTintColor:';
    function tintColor: UIColor; message 'tintColor';
    function numberOfSegments: NSUInteger; message 'numberOfSegments';
    procedure insertSegmentWithTitle_atIndex_animated(title: NSString; segment: NSUInteger; animated: Boolean); message 'insertSegmentWithTitle:atIndex:animated:';
    procedure insertSegmentWithImage_atIndex_animated(image: UIImage; segment: NSUInteger; animated: Boolean); message 'insertSegmentWithImage:atIndex:animated:';
    procedure removeSegmentAtIndex_animated(segment: NSUInteger; animated: Boolean); message 'removeSegmentAtIndex:animated:';
    procedure removeAllSegments; message 'removeAllSegments';
    procedure setTitle_forSegmentAtIndex(title: NSString; segment: NSUInteger); message 'setTitle:forSegmentAtIndex:';
    function titleForSegmentAtIndex(segment: NSUInteger): NSString; message 'titleForSegmentAtIndex:';
    procedure setImage_forSegmentAtIndex(image: UIImage; segment: NSUInteger); message 'setImage:forSegmentAtIndex:';
    function imageForSegmentAtIndex(segment: NSUInteger): UIImage; message 'imageForSegmentAtIndex:';
    procedure setWidth_forSegmentAtIndex(width: CGFloat; segment: NSUInteger); message 'setWidth:forSegmentAtIndex:';
    function widthForSegmentAtIndex(segment: NSUInteger): CGFloat; message 'widthForSegmentAtIndex:';
    procedure setContentOffset_forSegmentAtIndex(offset: CGSize; segment: NSUInteger); message 'setContentOffset:forSegmentAtIndex:';
    function contentOffsetForSegmentAtIndex(segment: NSUInteger): CGSize; message 'contentOffsetForSegmentAtIndex:';
    procedure setEnabled_forSegmentAtIndex(enabled: Boolean; segment: NSUInteger); message 'setEnabled:forSegmentAtIndex:';
    function isEnabledForSegmentAtIndex(segment: NSUInteger): Boolean; message 'isEnabledForSegmentAtIndex:';
    procedure setSelectedSegmentIndex (newValue: NSInteger); message 'setSelectedSegmentIndex:';
    function selectedSegmentIndex: NSInteger; message 'selectedSegmentIndex';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{$endif}
{$endif}
