{ Parsed from Uikit.framework UITabBarItem.h }

{$ifdef TYPES}
{$ifndef UITABBARITEM_PAS_T}
{$define UITABBARITEM_PAS_T}

{ Types }
type
  
  UITabBarSystemItem = culong;

{ Constants }

const
  UITabBarSystemItemMore = 0;
  UITabBarSystemItemFavorites = 1;
  UITabBarSystemItemFeatured = 2;
  UITabBarSystemItemTopRated = 3;
  UITabBarSystemItemRecents = 4;
  UITabBarSystemItemContacts = 5;
  UITabBarSystemItemHistory = 6;
  UITabBarSystemItemBookmarks = 7;
  UITabBarSystemItemSearch = 8;
  UITabBarSystemItemDownloads = 9;
  UITabBarSystemItemMostRecent = 10;
  UITabBarSystemItemMostViewed = 11;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UITABBARITEM_PAS_R}
{$define UITABBARITEM_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UITABBARITEM_PAS_F}
{$define UITABBARITEM_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UITABBARITEM_PAS_S}
{$define UITABBARITEM_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UITabBarItem = objcclass;
  UITabBarItemPointer = ^UITabBarItem;
  UITabBarItemPtr = UITabBarItemPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UITABBARITEM_PAS_C}
{$define UITABBARITEM_PAS_C}

{ UITabBarItem }
  UITabBarItem = objcclass external (UIBarItem)
  private
    _title: NSString;
    _possibleTitles: NSSet;
    _action: SEL;
    _target: id;
    _image: UIImage;
    _selectedImage: UIImage;
    _unselectedImage: UIImage;
    _imageInsets: UIEdgeInsets;
    _badgeValue: NSString;
    _view: UIView;
    _tag: NSInteger;
    __tabBarItemFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UITabBarItem0: cuint);
       1: (
        enabled: 0..1;
        style: 0..((1 shl 3)-1);
        isSystemItem: 0..1;
        systemItem: 0..((1 shl 7)-1);
        viewIsCustom: 0..1;
        animatedBadge: 0..1;
        customSelectedImage: 0..1;
        customUnselectedImage: 0..1;
      );
      end;
    
  public
    function initWithTitle_image_tag(title_: NSString; image_: UIImage; tag_: NSInteger): id; message 'initWithTitle:image:tag:';
    function initWithTabBarSystemItem_tag(systemItem: UITabBarSystemItem; tag_: NSInteger): id; message 'initWithTabBarSystemItem:tag:';
    procedure setBadgeValue (newValue: NSString); message 'setBadgeValue:';
    function badgeValue: NSString; message 'badgeValue';
  end;

{$endif}
{$endif}
