{ Parsed from Uikit.framework UITableView.h }

{$ifdef TYPES}
{$ifndef UITABLEVIEW_PAS_T}
{$define UITABLEVIEW_PAS_T}

{ Types }
type
  
  UITableViewStyle = culong;
  UITableViewScrollPosition = culong;
  UITableViewRowAnimation = culong;

{ Constants }

const
  UITableViewStylePlain = 0;
  UITableViewStyleGrouped = 1;

const
  UITableViewScrollPositionNone = 0;
  UITableViewScrollPositionTop = 1;
  UITableViewScrollPositionMiddle = 2;
  UITableViewScrollPositionBottom = 3;

const
  UITableViewRowAnimationFade = 0;
  UITableViewRowAnimationRight = 1;
  UITableViewRowAnimationLeft = 2;
  UITableViewRowAnimationTop = 3;
  UITableViewRowAnimationBottom = 4;
  UITableViewRowAnimationNone = 5;
  UITableViewRowAnimationMiddle = 6;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UITABLEVIEW_PAS_R}
{$define UITABLEVIEW_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UITABLEVIEW_PAS_F}
{$define UITABLEVIEW_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UITABLEVIEW_PAS_S}
{$define UITABLEVIEW_PAS_S}

{ External string constants }
var
  UITableViewIndexSearch: NSString; cvar; external;
  UITableViewSelectionDidChangeNotification: NSString; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UITableViewDelegateProtocol = objcprotocol;
  UITableViewDataSourceProtocol = objcprotocol;
  UITableView = objcclass;
  UITableViewPointer = ^UITableView;
  UITableViewPtr = UITableViewPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UITABLEVIEW_PAS_C}
{$define UITABLEVIEW_PAS_C}

{ UITableView }
  UITableView = objcclass external (UIScrollView, NSCodingProtocol)
  private
    _style: UITableViewStyle;
    _dataSource: UITableViewDataSourceProtocol;
    _rowData: id;
    _rowHeight: CGFloat;
    _sectionHeaderHeight: CGFloat;
    _sectionFooterHeight: CGFloat;
    _visibleBounds: CGRect;
    _visibleRows: NSRange;
    _visibleCells: NSMutableArray;
    _firstResponderIndexPath: NSIndexPath;
    _firstResponderView: UIView;
    _firstResponderViewType: NSUInteger;
    _reusableTableCells: NSMutableDictionary;
    _topSeparatorCell: UITableViewCell;
    _topSeparator: id;
    _extraSeparators: NSMutableArray;
    _visibleHeaderViews: CFMutableDictionaryRef;
    _visibleFooterViews: CFMutableDictionaryRef;
    _reusableHeaderViews: NSMutableArray;
    _reusableFooterViews: NSMutableArray;
    _reusableTransparentHeaderViews: NSMutableArray;
    _reusableTransparentFooterViews: NSMutableArray;
    _highlightedIndexPaths: NSMutableArray;
    _selectedIndexPaths: NSMutableArray;
    _swipeToDeleteSection: NSInteger;
    _swipeToDeleteRow: NSInteger;
    _pendingSelectionIndexPath: NSIndexPath;
    _pendingDeselectionIndexPaths: NSArray;
    _touchedContentView: UIView;
    _newContentView: UIView;
    _deleteAnimationSupport: id;
    _reorderingSupport: id;
    _backgroundView: UIView;
    _index: UIView;
    _tableHeaderBackgroundView: UIView;
    _tableHeaderView: UIView;
    _tableFooterView: UIView;
    _countLabel: id;
    _tableReloadingSuspendedCount: NSInteger;
    _tableDisplaySuspendedCount: NSInteger;
    _sectionIndexMinimumDisplayRowCount: NSInteger;
    _itemCountFooterMinimumDisplayRowCount: NSInteger;
    _insertItems: NSMutableArray;
    _deleteItems: NSMutableArray;
    _reloadItems: NSMutableArray;
    _separatorColor: UIColor;
    _separatorTopShadowColor: UIColor;
    _separatorBottomShadowColor: UIColor;
    _checkmarkColor: UIColor;
    _sectionBorderColor: UIColor;
    _defaultSectionIndexTitles: NSArray;
    _swipeGestureRecognizer: UISwipeGestureRecognizer;
    _updateCount: NSInteger;
    _reserved: id;
    __tableFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UITableView0: cuint);
       1: (
        dataSourceNumberOfRowsInSection: 0..1;
        dataSourceCellForRow: 0..1;
        dataSourceNumberOfSectionsInTableView: 0..1;
        dataSourceTitleForHeaderInSection: 0..1;
        dataSourceTitleForFooterInSection: 0..1;
        dataSourceCommitEditingStyle: 0..1;
        dataSourceSectionIndexTitlesForTableView: 0..1;
        dataSourceSectionForSectionIndexTitle: 0..1;
        dataSourceCanEditRow: 0..1;
        dataSourceCanMoveRow: 0..1;
        dataSourceCanUpdateRow: 0..1;
        dataSourceShouldShowMenu: 0..1;
        dataSourceCanPerformAction: 0..1;
        dataSourcePerformAction: 0..1;
        dataSourceIndexPathForSectionIndexTitle: 0..1;
        delegateEditingStyleForRowAtIndexPath: 0..1;
        delegateTitleForDeleteConfirmationButtonForRowAtIndexPath: 0..1;
        delegateShouldIndentWhileEditing: 0..1;
        dataSourceMoveRow: 0..1;
        delegateCellForRow: 0..1;
        delegateWillDisplayCell: 0..1;
        delegateHeightForRow: 0..1;
        delegateHeightForSectionHeader: 0..1;
        delegateTitleWidthForSectionHeader: 0..1;
        delegateHeightForSectionFooter: 0..1;
        delegateTitleWidthForSectionFooter: 0..1;
        delegateViewForHeaderInSection: 0..1;
        delegateViewForFooterInSection: 0..1;
        delegateDisplayedItemCountForRowCount: 0..1;
        delegateDisplayStringForRowCount: 0..1;
        delegateAccessoryTypeForRow: 0..1;
        delegateAccessoryButtonTappedForRow: 0..1;
        delegateWillSelectRow: 0..1;
        delegateWillDeselectRow: 0..1;
        delegateDidSelectRow: 0..1;
        delegateDidDeselectRow: 0..1;
        delegateWillBeginEditing: 0..1;
        delegateDidEndEditing: 0..1;
        delegateWillMoveToRow: 0..1;
        delegateIndentationLevelForRow: 0..1;
        delegateWantsHeaderForSection: 0..1;
        delegateHeightForRowsInSection: 0..1;
        delegateMargin: 0..1;
        delegateHeaderTitleAlignment: 0..1;
        delegateFooterTitleAlignment: 0..1;
        delegateFrameForSectionIndexGivenProposedFrame: 0..1;
        delegateDidFinishReload: 0..1;
        delegateHeightForHeader: 0..1;
        delegateHeightForFooter: 0..1;
        delegateViewForHeader: 0..1;
        delegateViewForFooter: 0..1;
        style: 0..1;
        separatorStyle: 0..((1 shl 3)-1);
        wasEditing: 0..1;
        isEditing: 0..1;
        scrollsToSelection: 0..1;
        reloadSkippedDuringSuspension: 0..1;
        updating: 0..1;
        displaySkippedDuringSuspension: 0..1;
        needsReload: 0..1;
        updatingVisibleCellsManually: 0..1;
        scheduledUpdateVisibleCells: 0..1;
        scheduledUpdateVisibleCellsFrames: 0..1;
        warnForForcedCellUpdateDisabled: 0..1;
        displayTopSeparator: 0..1;
        countStringInsignificantRowCount: 0..((1 shl 4)-1);
        needToAdjustExtraSeparators: 0..1;
        overlapsSectionHeaderViews: 0..1;
        ignoreDragSwipe: cuint;
        ignoreTouchSelect: 0..1;
        lastHighlightedRowActive: 0..1;
        reloading: 0..1;
        allowsSelection: 0..1;
        allowsSelectionDuringEditing: 0..1;
        showsSelectionImmediatelyOnTouchBegin: 0..1;
        indexHidden: 0..1;
        indexHiddenForSearch: 0..1;
        defaultShowsHorizontalScrollIndicator: 0..1;
        defaultShowsVerticalScrollIndicator: 0..1;
        sectionIndexTitlesLoaded: 0..1;
        tableHeaderViewShouldAutoHide: 0..1;
        tableHeaderViewIsHidden: 0..1;
        tableHeaderViewWasHidden: 0..1;
        hideScrollIndicators: 0..1;
        sendReloadFinished: 0..1;
        keepFirstResponderWhenInteractionDisabled: 0..1;
        keepFirstResponderVisibleOnBoundsChange: 0..1;
      );
      end;
    _selectedSection: cuint;
    _selectedRow: cuint;
    _lastSelectedSection: cuint;
    _lastSelectedRow: cuint;
    
  public
    function initWithFrame_style(frame_: CGRect; style: UITableViewStyle): id; message 'initWithFrame:style:';
    function style: UITableViewStyle; message 'style';
    procedure setDataSource (newValue: id); message 'setDataSource:';
    function dataSource: id; message 'dataSource';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setRowHeight (newValue: CGFloat); message 'setRowHeight:';
    function rowHeight: CGFloat; message 'rowHeight';
    procedure setSectionHeaderHeight (newValue: CGFloat); message 'setSectionHeaderHeight:';
    function sectionHeaderHeight: CGFloat; message 'sectionHeaderHeight';
    procedure setSectionFooterHeight (newValue: CGFloat); message 'setSectionFooterHeight:';
    function sectionFooterHeight: CGFloat; message 'sectionFooterHeight';
    procedure setBackgroundView (newValue: UIView); message 'setBackgroundView:';
    function backgroundView: UIView; message 'backgroundView';
    procedure reloadData; message 'reloadData';
    procedure reloadSectionIndexTitles; message 'reloadSectionIndexTitles';
    function numberOfSections: NSInteger; message 'numberOfSections';
    function numberOfRowsInSection(section: NSInteger): NSInteger; message 'numberOfRowsInSection:';
    function rectForSection(section: NSInteger): CGRect; message 'rectForSection:';
    function rectForHeaderInSection(section: NSInteger): CGRect; message 'rectForHeaderInSection:';
    function rectForFooterInSection(section: NSInteger): CGRect; message 'rectForFooterInSection:';
    function rectForRowAtIndexPath(indexPath: NSIndexPath): CGRect; message 'rectForRowAtIndexPath:';
    function indexPathForRowAtPoint(point: CGPoint): NSIndexPath; message 'indexPathForRowAtPoint:';
    function indexPathForCell(cell: UITableViewCell): NSIndexPath; message 'indexPathForCell:';
    function indexPathsForRowsInRect(rect: CGRect): NSArray; message 'indexPathsForRowsInRect:';
    function cellForRowAtIndexPath(indexPath: NSIndexPath): UITableViewCell; message 'cellForRowAtIndexPath:';
    function visibleCells: NSArray; message 'visibleCells';
    function indexPathsForVisibleRows: NSArray; message 'indexPathsForVisibleRows';
    procedure scrollToRowAtIndexPath_atScrollPosition_animated(indexPath: NSIndexPath; scrollPosition: UITableViewScrollPosition; animated: Boolean); message 'scrollToRowAtIndexPath:atScrollPosition:animated:';
    procedure scrollToNearestSelectedRowAtScrollPosition_animated(scrollPosition: UITableViewScrollPosition; animated: Boolean); message 'scrollToNearestSelectedRowAtScrollPosition:animated:';
    procedure beginUpdates; message 'beginUpdates';
    procedure endUpdates; message 'endUpdates';
    procedure insertSections_withRowAnimation(sections: NSIndexSet; animation: UITableViewRowAnimation); message 'insertSections:withRowAnimation:';
    procedure deleteSections_withRowAnimation(sections: NSIndexSet; animation: UITableViewRowAnimation); message 'deleteSections:withRowAnimation:';
    procedure reloadSections_withRowAnimation(sections: NSIndexSet; animation: UITableViewRowAnimation); message 'reloadSections:withRowAnimation:';
    procedure insertRowsAtIndexPaths_withRowAnimation(indexPaths: NSArray; animation: UITableViewRowAnimation); message 'insertRowsAtIndexPaths:withRowAnimation:';
    procedure deleteRowsAtIndexPaths_withRowAnimation(indexPaths: NSArray; animation: UITableViewRowAnimation); message 'deleteRowsAtIndexPaths:withRowAnimation:';
    procedure reloadRowsAtIndexPaths_withRowAnimation(indexPaths: NSArray; animation: UITableViewRowAnimation); message 'reloadRowsAtIndexPaths:withRowAnimation:';
    procedure setEditing (newValue: Boolean); message 'setEditing:';
    function isEditing: Boolean; message 'isEditing';
    procedure setEditing_animated(editing: Boolean; animated: Boolean); message 'setEditing:animated:';
    procedure setAllowsSelection (newValue: Boolean); message 'setAllowsSelection:';
    function allowsSelection: Boolean; message 'allowsSelection';
    procedure setAllowsSelectionDuringEditing (newValue: Boolean); message 'setAllowsSelectionDuringEditing:';
    function allowsSelectionDuringEditing: Boolean; message 'allowsSelectionDuringEditing';
    function indexPathForSelectedRow: NSIndexPath; message 'indexPathForSelectedRow';
    procedure selectRowAtIndexPath_animated_scrollPosition(indexPath: NSIndexPath; animated: Boolean; scrollPosition: UITableViewScrollPosition); message 'selectRowAtIndexPath:animated:scrollPosition:';
    procedure deselectRowAtIndexPath_animated(indexPath: NSIndexPath; animated: Boolean); message 'deselectRowAtIndexPath:animated:';
    procedure setSectionIndexMinimumDisplayRowCount (newValue: NSInteger); message 'setSectionIndexMinimumDisplayRowCount:';
    function sectionIndexMinimumDisplayRowCount: NSInteger; message 'sectionIndexMinimumDisplayRowCount';
    procedure setSeparatorStyle (newValue: UITableViewCellSeparatorStyle); message 'setSeparatorStyle:';
    function separatorStyle: UITableViewCellSeparatorStyle; message 'separatorStyle';
    procedure setSeparatorColor (newValue: UIColor); message 'setSeparatorColor:';
    function separatorColor: UIColor; message 'separatorColor';
    procedure setTableHeaderView (newValue: UIView); message 'setTableHeaderView:';
    function tableHeaderView: UIView; message 'tableHeaderView';
    procedure setTableFooterView (newValue: UIView); message 'setTableFooterView:';
    function tableFooterView: UIView; message 'tableFooterView';
    function dequeueReusableCellWithIdentifier(identifier: NSString): UITableViewCell; message 'dequeueReusableCellWithIdentifier:';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{ UITableView_NSIndexPathCategory }
  UITableView_NSIndexPathCategory = objccategory external name 'UITableView' (NSIndexPath)
    class function indexPathForRow_inSection(row: NSUInteger; section: NSUInteger): NSIndexPath; message 'indexPathForRow:inSection:';
    function section: NSUInteger; message 'section';
    function row: NSUInteger; message 'row';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UITABLEVIEW_PAS_P}
{$define UITABLEVIEW_PAS_P}
  
{ UITableViewDelegate Protocol }
  UITableViewDelegateProtocol = objcprotocol external name 'UITableViewDelegate'
  optional
    procedure tableView_willDisplayCell_forRowAtIndexPath(tableView: UITableView; cell: UITableViewCell; indexPath: NSIndexPath); message 'tableView:willDisplayCell:forRowAtIndexPath:';
    function tableView_heightForRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): CGFloat; message 'tableView:heightForRowAtIndexPath:';
    function tableView_heightForHeaderInSection(tableView: UITableView; section: NSInteger): CGFloat; message 'tableView:heightForHeaderInSection:';
    function tableView_heightForFooterInSection(tableView: UITableView; section: NSInteger): CGFloat; message 'tableView:heightForFooterInSection:';
    function tableView_viewForHeaderInSection(tableView: UITableView; section: NSInteger): UIView; message 'tableView:viewForHeaderInSection:';
    function tableView_viewForFooterInSection(tableView: UITableView; section: NSInteger): UIView; message 'tableView:viewForFooterInSection:';
    function tableView_accessoryTypeForRowWithIndexPath(tableView: UITableView; indexPath: NSIndexPath): UITableViewCellAccessoryType; message 'tableView:accessoryTypeForRowWithIndexPath:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure tableView_accessoryButtonTappedForRowWithIndexPath(tableView: UITableView; indexPath: NSIndexPath); message 'tableView:accessoryButtonTappedForRowWithIndexPath:';
    function tableView_willSelectRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): NSIndexPath; message 'tableView:willSelectRowAtIndexPath:';
    function tableView_willDeselectRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): NSIndexPath; message 'tableView:willDeselectRowAtIndexPath:';
    procedure tableView_didSelectRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath); message 'tableView:didSelectRowAtIndexPath:';
    procedure tableView_didDeselectRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath); message 'tableView:didDeselectRowAtIndexPath:';
    function tableView_editingStyleForRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): UITableViewCellEditingStyle; message 'tableView:editingStyleForRowAtIndexPath:';
    function tableView_titleForDeleteConfirmationButtonForRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): NSString; message 'tableView:titleForDeleteConfirmationButtonForRowAtIndexPath:';
    function tableView_shouldIndentWhileEditingRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): Boolean; message 'tableView:shouldIndentWhileEditingRowAtIndexPath:';
    procedure tableView_willBeginEditingRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath); message 'tableView:willBeginEditingRowAtIndexPath:';
    procedure tableView_didEndEditingRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath); message 'tableView:didEndEditingRowAtIndexPath:';
    function tableView_targetIndexPathForMoveFromRowAtIndexPath_toProposedIndexPath(tableView: UITableView; sourceIndexPath: NSIndexPath; proposedDestinationIndexPath: NSIndexPath): NSIndexPath; message 'tableView:targetIndexPathForMoveFromRowAtIndexPath:toProposedIndexPath:';
    function tableView_indentationLevelForRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): NSInteger; message 'tableView:indentationLevelForRowAtIndexPath:';
  end;
  
{ UITableViewDataSource Protocol }
  UITableViewDataSourceProtocol = objcprotocol external name 'UITableViewDataSource'
  required
    function tableView_numberOfRowsInSection(tableView: UITableView; section: NSInteger): NSInteger; message 'tableView:numberOfRowsInSection:';
    function tableView_cellForRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): UITableViewCell; message 'tableView:cellForRowAtIndexPath:';
  optional
    function numberOfSectionsInTableView(tableView: UITableView): NSInteger; message 'numberOfSectionsInTableView:';
    function tableView_titleForHeaderInSection(tableView: UITableView; section: NSInteger): NSString; message 'tableView:titleForHeaderInSection:';
    function tableView_titleForFooterInSection(tableView: UITableView; section: NSInteger): NSString; message 'tableView:titleForFooterInSection:';
    function tableView_canEditRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): Boolean; message 'tableView:canEditRowAtIndexPath:';
    function tableView_canMoveRowAtIndexPath(tableView: UITableView; indexPath: NSIndexPath): Boolean; message 'tableView:canMoveRowAtIndexPath:';
    function sectionIndexTitlesForTableView(tableView: UITableView): NSArray; message 'sectionIndexTitlesForTableView:';
    function tableView_sectionForSectionIndexTitle_atIndex(tableView: UITableView; title: NSString; index: NSInteger): NSInteger; message 'tableView:sectionForSectionIndexTitle:atIndex:';
    procedure tableView_commitEditingStyle_forRowAtIndexPath(tableView: UITableView; editingStyle: UITableViewCellEditingStyle; indexPath: NSIndexPath); message 'tableView:commitEditingStyle:forRowAtIndexPath:';
    procedure tableView_moveRowAtIndexPath_toIndexPath(tableView: UITableView; sourceIndexPath: NSIndexPath; destinationIndexPath: NSIndexPath); message 'tableView:moveRowAtIndexPath:toIndexPath:';
  end;
{$endif}
{$endif}
