{ Parsed from Uikit.framework UITableViewCell.h }

{$ifdef TYPES}
{$ifndef UITABLEVIEWCELL_PAS_T}
{$define UITABLEVIEWCELL_PAS_T}

{ Types }
type
  
  UITableViewCellStyle = culong;
  UITableViewCellSeparatorStyle = culong;
  UITableViewCellSelectionStyle = culong;
  UITableViewCellEditingStyle = culong;
  UITableViewCellAccessoryType = culong;

{ Constants }

const
  UITableViewCellStyleDefault = 0;
  UITableViewCellStyleValue1 = 1;
  UITableViewCellStyleValue2 = 2;
  UITableViewCellStyleSubtitle = 3;

const
  UITableViewCellSeparatorStyleNone = 0;
  UITableViewCellSeparatorStyleSingleLine = 1;
  UITableViewCellSeparatorStyleSingleLineEtched = 2;

const
  UITableViewCellSelectionStyleNone = 0;
  UITableViewCellSelectionStyleBlue = 1;
  UITableViewCellSelectionStyleGray = 2;

const
  UITableViewCellEditingStyleNone = 0;
  UITableViewCellEditingStyleDelete = 1;
  UITableViewCellEditingStyleInsert = 2;

const
  UITableViewCellAccessoryNone = 0;
  UITableViewCellAccessoryDisclosureIndicator = 1;
  UITableViewCellAccessoryDetailDisclosureButton = 2;
  UITableViewCellAccessoryCheckmark = 3;

const
  UITableViewCellStateDefaultMask = 0;
  UITableViewCellStateShowingEditControlMask = 1 shl 0;
  UITableViewCellStateShowingDeleteConfirmationMask = 1 shl 1;

{ Types }
type
  UITableViewCellStateMask = NSUInteger;
  UITableViewCellStateMaskPtr = ^UITableViewCellStateMask;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UITABLEVIEWCELL_PAS_R}
{$define UITABLEVIEWCELL_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UITABLEVIEWCELL_PAS_F}
{$define UITABLEVIEWCELL_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UITABLEVIEWCELL_PAS_S}
{$define UITABLEVIEWCELL_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UITableViewCell = objcclass;
  UITableViewCellPointer = ^UITableViewCell;
  UITableViewCellPtr = UITableViewCellPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UITABLEVIEWCELL_PAS_C}
{$define UITABLEVIEWCELL_PAS_C}

{ UITableViewCell }
  UITableViewCell = objcclass external (UIView, NSCodingProtocol)
  private
    _layoutManager: id;
    _target: id;
    _editAction: SEL;
    _accessoryAction: SEL;
    _oldEditingData: id;
    _editingData: id;
    _rightMargin: CGFloat;
    _indentationLevel: NSInteger;
    _indentationWidth: CGFloat;
    _reuseIdentifier: NSString;
    _contentView: UIView;
    _imageView: UIImageView;
    _textLabel: UILabel;
    _detailTextLabel: UILabel;
    _backgroundView: UIView;
    _selectedBackgroundView: UIView;
    _selectedOverlayView: UIView;
    _selectionFadeDuration: CGFloat;
    _backgroundColor: UIColor;
    _separatorColor: UIColor;
    _topShadowColor: UIColor;
    _bottomShadowColor: UIColor;
    _sectionBorderColor: UIColor;
    _floatingSeparatorView: UIView;
    _topShadowAnimationView: UIView;
    _bottomShadowAnimationView: UIView;
    _unhighlightedStates: CFMutableDictionaryRef;
    __tableCellFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UITableViewCell0: cuint);
       1: (
        showingDeleteConfirmation: 0..1;
        separatorStyle: 0..((1 shl 3)-1);
        selectionStyle: 0..((1 shl 3)-1);
        selectionFadeFraction: 0..((1 shl 11)-1);
        editing: 0..1;
        editingStyle: 0..((1 shl 3)-1);
        accessoryType: 0..((1 shl 3)-1);
        editingAccessoryType: 0..((1 shl 3)-1);
        showsAccessoryWhenEditing: 0..1;
        showsReorderControl: 0..1;
        showDisclosure: 0..1;
        showTopSeparator: 0..1;
        disclosureClickable: 0..1;
        disclosureStyle: 0..1;
        showingRemoveControl: 0..1;
        sectionLocation: 0..((1 shl 3)-1);
        tableViewStyle: 0..1;
        shouldIndentWhileEditing: 0..1;
        fontSet: 0..1;
        usingDefaultSelectedBackgroundView: 0..1;
        wasSwiped: 0..1;
        highlighted: 0..1;
        separatorDirty: 0..1;
        drawn: 0..1;
        drawingDisabled: 0..1;
        style: 0..((1 shl 12)-1);
        showingMenu: 0..1;
        clipsContents: 0..1;
        animatingSelection: 0..1;
        backgroundColorSet: 0..1;
        needsSetup: 0..1;
      );
      end;
    _accessoryView: UIButton;
    _editingAccessoryView: UIButton;
    _customAccessoryView: UIView;
    _customEditingAccessoryView: UIView;
    _separatorView: UIView;
    _topSeparatorView: UIView;
    _topShadowView: UIView;
    _editableTextField: UITextField;
    _lastSelectionTime: CFAbsoluteTime;
    _deselectTimer: NSTimer;
    _textFieldOffset: CGFloat;
    _returnAction: SEL;
    
  public
    function initWithStyle_reuseIdentifier(style: UITableViewCellStyle; reuseIdentifier: NSString): id; message 'initWithStyle:reuseIdentifier:';
    function imageView: UIImageView; message 'imageView';
    function textLabel: UILabel; message 'textLabel';
    function detailTextLabel: UILabel; message 'detailTextLabel';
    function contentView: UIView; message 'contentView';
    procedure setBackgroundView (newValue: UIView); message 'setBackgroundView:';
    function backgroundView: UIView; message 'backgroundView';
    procedure setSelectedBackgroundView (newValue: UIView); message 'setSelectedBackgroundView:';
    function selectedBackgroundView: UIView; message 'selectedBackgroundView';
    function reuseIdentifier: NSString; message 'reuseIdentifier';
    procedure prepareForReuse; message 'prepareForReuse';
    procedure setSelectionStyle (newValue: UITableViewCellSelectionStyle); message 'setSelectionStyle:';
    function selectionStyle: UITableViewCellSelectionStyle; message 'selectionStyle';
    procedure setSelected (newValue: Boolean); message 'setSelected:';
    function isSelected: Boolean; message 'isSelected';
    procedure setHighlighted (newValue: Boolean); message 'setHighlighted:';
    function isHighlighted: Boolean; message 'isHighlighted';
    procedure setSelected_animated(selected: Boolean; animated: Boolean); message 'setSelected:animated:';
    procedure setHighlighted_animated(highlighted: Boolean; animated: Boolean); message 'setHighlighted:animated:';
    function editingStyle: UITableViewCellEditingStyle; message 'editingStyle';
    procedure setShowsReorderControl (newValue: Boolean); message 'setShowsReorderControl:';
    function showsReorderControl: Boolean; message 'showsReorderControl';
    procedure setShouldIndentWhileEditing (newValue: Boolean); message 'setShouldIndentWhileEditing:';
    function shouldIndentWhileEditing: Boolean; message 'shouldIndentWhileEditing';
    procedure setAccessoryType (newValue: UITableViewCellAccessoryType); message 'setAccessoryType:';
    function accessoryType: UITableViewCellAccessoryType; message 'accessoryType';
    procedure setAccessoryView (newValue: UIView); message 'setAccessoryView:';
    function accessoryView: UIView; message 'accessoryView';
    procedure setEditingAccessoryType (newValue: UITableViewCellAccessoryType); message 'setEditingAccessoryType:';
    function editingAccessoryType: UITableViewCellAccessoryType; message 'editingAccessoryType';
    procedure setEditingAccessoryView (newValue: UIView); message 'setEditingAccessoryView:';
    function editingAccessoryView: UIView; message 'editingAccessoryView';
    procedure setIndentationLevel (newValue: NSInteger); message 'setIndentationLevel:';
    function indentationLevel: NSInteger; message 'indentationLevel';
    procedure setIndentationWidth (newValue: CGFloat); message 'setIndentationWidth:';
    function indentationWidth: CGFloat; message 'indentationWidth';
    procedure setEditing (newValue: Boolean); message 'setEditing:';
    function isEditing: Boolean; message 'isEditing';
    procedure setEditing_animated(editing: Boolean; animated: Boolean); message 'setEditing:animated:';
    function showingDeleteConfirmation: Boolean; message 'showingDeleteConfirmation';
    procedure willTransitionToState(state: UITableViewCellStateMask); message 'willTransitionToState:';
    procedure didTransitionToState(state: UITableViewCellStateMask); message 'didTransitionToState:';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{ UIDeprecatedCategory }
  UIDeprecatedCategory = objccategory external (UITableViewCell)
    function initWithFrame_reuseIdentifier(frame_: CGRect; reuseIdentifier_: NSString): id; message 'initWithFrame:reuseIdentifier:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setText (newValue: NSString); message 'setText:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function text: NSString; message 'text'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setFont (newValue: UIFont); message 'setFont:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function font: UIFont; message 'font'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setTextAlignment (newValue: UITextAlignment); message 'setTextAlignment:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function textAlignment: UITextAlignment; message 'textAlignment'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setLineBreakMode (newValue: UILineBreakMode); message 'setLineBreakMode:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function lineBreakMode: UILineBreakMode; message 'lineBreakMode'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setTextColor (newValue: UIColor); message 'setTextColor:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function textColor: UIColor; message 'textColor'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setSelectedTextColor (newValue: UIColor); message 'setSelectedTextColor:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function selectedTextColor: UIColor; message 'selectedTextColor'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setImage (newValue: UIImage); message 'setImage:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function image: UIImage; message 'image'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setSelectedImage (newValue: UIImage); message 'setSelectedImage:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function selectedImage: UIImage; message 'selectedImage'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setHidesAccessoryWhenEditing (newValue: Boolean); message 'setHidesAccessoryWhenEditing:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function hidesAccessoryWhenEditing: Boolean; message 'hidesAccessoryWhenEditing'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setTarget (newValue: id); message 'setTarget:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function target: id; message 'target'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setEditAction (newValue: SEL); message 'setEditAction:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function editAction: SEL; message 'editAction'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    procedure setAccessoryAction (newValue: SEL); message 'setAccessoryAction:'; deprecated 'in __IPHONE_2_0 and later, in  and later';
    function accessoryAction: SEL; message 'accessoryAction'; deprecated 'in __IPHONE_2_0 and later, in  and later';
  end;

{$endif}
{$endif}
