{ Parsed from Uikit.framework UITextField.h }

{$ifdef TYPES}
{$ifndef UITEXTFIELD_PAS_T}
{$define UITEXTFIELD_PAS_T}

{ Types }
type
  
  UITextBorderStyle = culong;
  UITextFieldViewMode = culong;

{ Constants }

const
  UITextBorderStyleNone = 0;
  UITextBorderStyleLine = 1;
  UITextBorderStyleBezel = 2;
  UITextBorderStyleRoundedRect = 3;

const
  UITextFieldViewModeNever = 0;
  UITextFieldViewModeWhileEditing = 1;
  UITextFieldViewModeUnlessEditing = 2;
  UITextFieldViewModeAlways = 3;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UITEXTFIELD_PAS_R}
{$define UITEXTFIELD_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UITEXTFIELD_PAS_F}
{$define UITEXTFIELD_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UITEXTFIELD_PAS_S}
{$define UITEXTFIELD_PAS_S}

{ External string constants }
var
  UITextFieldTextDidBeginEditingNotification: NSString; cvar; external;
  UITextFieldTextDidEndEditingNotification: NSString; cvar; external;
  UITextFieldTextDidChangeNotification: NSString; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UITextFieldDelegateProtocol = objcprotocol;
  UITextField = objcclass;
  UITextFieldPointer = ^UITextField;
  UITextFieldPtr = UITextFieldPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UITEXTFIELD_PAS_C}
{$define UITEXTFIELD_PAS_C}

{ UITextField }
  UITextField = objcclass external (UIControl, UITextInputTraitsProtocol, NSCodingProtocol)
  private
    _text: NSString;
    _textColor: UIColor;
    _borderStyle: UITextBorderStyle;
    _minimumFontSize: CGFloat;
    _delegate: id;
    _background: UIImage;
    _disabledBackground: UIImage;
    _clearButtonMode: UITextFieldViewMode;
    _leftView: UIView;
    _leftViewMode: UITextFieldViewMode;
    _rightView: UIView;
    _rightViewMode: UITextFieldViewMode;
    _traits: UITextInputTraits;
    _nonAtomTraits: UITextInputTraits;
    _fullFontSize: CGFloat;
    _paddingLeft: CGFloat;
    _paddingTop: CGFloat;
    _paddingRight: CGFloat;
    _paddingBottom: CGFloat;
    _textFont: NSString;
    _caretColor: UIColor;
    _selectionRange: NSRange;
    _scrollXOffset: cint;
    _scrollYOffset: cint;
    _progress: single;
    _style: NSString;
    _mouseDownTime: CFTimeInterval;
    _clearButton: UIButton;
    _clearButtonOffset: CGSize;
    _leftViewOffset: CGSize;
    _rightViewOffset: CGSize;
    _backgroundView: UITextFieldBorderView;
    _disabledBackgroundView: UITextFieldBorderView;
    _systemBackgroundView: UITextFieldBackgroundView;
    _textLabel: UITextFieldLabel;
    _placeholderLabel: UITextFieldLabel;
    _iconView: UIImageView;
    _label: UILabel;
    _labelOffset: CGFloat;
    _interactionAssistant: UITextInteractionAssistant;
    _selectionView: UITextSelectionView;
    _inputView: UIView;
    _inputAccessoryView: UIView;
    _atomBackgroundView: UITextFieldAtomBackgroundView;
    __textFieldFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UITextField0: cuint);
       1: (
        secureTextChanged: 0..1;
        guard: 0..1;
        delegateRespondsToHandleKeyDown: 0..1;
        verticallyCenterText: 0..1;
        isAnimating: 0..((1 shl 4)-1);
        inactiveHasDimAppearance: 0..1;
        becomesFirstResponderOnClearButtonTap: 0..1;
        clearsOnBeginEditing: 0..1;
        adjustsFontSizeToFitWidth: 0..1;
        fieldEditorAttached: 0..1;
        _canBecomeFirstResponder: 0..1;
        inResignFirstResponder: 0..1;
        undoDisabled: 0..1;
        contentsRTL: 0..1;
        explicitAlignment: 0..1;
      );
      end;
    
  public
    procedure setText (newValue: NSString); message 'setText:';
    function text: NSString; message 'text';
    procedure setTextColor (newValue: UIColor); message 'setTextColor:';
    function textColor: UIColor; message 'textColor';
    procedure setFont (newValue: UIFont); message 'setFont:';
    function font: UIFont; message 'font';
    procedure setTextAlignment (newValue: UITextAlignment); message 'setTextAlignment:';
    function textAlignment: UITextAlignment; message 'textAlignment';
    procedure setBorderStyle (newValue: UITextBorderStyle); message 'setBorderStyle:';
    function borderStyle: UITextBorderStyle; message 'borderStyle';
    procedure setPlaceholder (newValue: NSString); message 'setPlaceholder:';
    function placeholder: NSString; message 'placeholder';
    procedure setClearsOnBeginEditing (newValue: Boolean); message 'setClearsOnBeginEditing:';
    function clearsOnBeginEditing: Boolean; message 'clearsOnBeginEditing';
    procedure setAdjustsFontSizeToFitWidth (newValue: Boolean); message 'setAdjustsFontSizeToFitWidth:';
    function adjustsFontSizeToFitWidth: Boolean; message 'adjustsFontSizeToFitWidth';
    procedure setMinimumFontSize (newValue: CGFloat); message 'setMinimumFontSize:';
    function minimumFontSize: CGFloat; message 'minimumFontSize';
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setBackground (newValue: UIImage); message 'setBackground:';
    function background: UIImage; message 'background';
    procedure setDisabledBackground (newValue: UIImage); message 'setDisabledBackground:';
    function disabledBackground: UIImage; message 'disabledBackground';
    function isEditing: Boolean; message 'isEditing';
    procedure setClearButtonMode (newValue: UITextFieldViewMode); message 'setClearButtonMode:';
    function clearButtonMode: UITextFieldViewMode; message 'clearButtonMode';
    procedure setLeftView (newValue: UIView); message 'setLeftView:';
    function leftView: UIView; message 'leftView';
    procedure setLeftViewMode (newValue: UITextFieldViewMode); message 'setLeftViewMode:';
    function leftViewMode: UITextFieldViewMode; message 'leftViewMode';
    procedure setRightView (newValue: UIView); message 'setRightView:';
    function rightView: UIView; message 'rightView';
    procedure setRightViewMode (newValue: UITextFieldViewMode); message 'setRightViewMode:';
    function rightViewMode: UITextFieldViewMode; message 'rightViewMode';
    function borderRectForBounds(bounds_: CGRect): CGRect; message 'borderRectForBounds:';
    function textRectForBounds(bounds_: CGRect): CGRect; message 'textRectForBounds:';
    function placeholderRectForBounds(bounds_: CGRect): CGRect; message 'placeholderRectForBounds:';
    function editingRectForBounds(bounds_: CGRect): CGRect; message 'editingRectForBounds:';
    function clearButtonRectForBounds(bounds_: CGRect): CGRect; message 'clearButtonRectForBounds:';
    function leftViewRectForBounds(bounds_: CGRect): CGRect; message 'leftViewRectForBounds:';
    function rightViewRectForBounds(bounds_: CGRect): CGRect; message 'rightViewRectForBounds:';
    procedure drawTextInRect(rect: CGRect); message 'drawTextInRect:';
    procedure drawPlaceholderInRect(rect: CGRect); message 'drawPlaceholderInRect:';
    procedure setInputView (newValue: UIView); message 'setInputView:';
    function inputView: UIView; message 'inputView';
    procedure setInputAccessoryView (newValue: UIView); message 'setInputAccessoryView:';
    function inputAccessoryView: UIView; message 'inputAccessoryView';

    { Adopted Protocols }
    procedure setAutocapitalizationType (newValue: UITextAutocapitalizationType);
    function autocapitalizationType: UITextAutocapitalizationType;
    procedure setAutocorrectionType (newValue: UITextAutocorrectionType);
    function autocorrectionType: UITextAutocorrectionType;
    procedure setKeyboardType (newValue: UIKeyboardType);
    function keyboardType: UIKeyboardType;
    procedure setKeyboardAppearance (newValue: UIKeyboardAppearance);
    function keyboardAppearance: UIKeyboardAppearance;
    procedure setReturnKeyType (newValue: UIReturnKeyType);
    function returnKeyType: UIReturnKeyType;
    procedure setEnablesReturnKeyAutomatically (newValue: Boolean);
    function enablesReturnKeyAutomatically: Boolean;
    procedure setSecureTextEntry (newValue: Boolean);
    function isSecureTextEntry: Boolean;
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{ UITextField_UIViewCategory }
  UITextField_UIViewCategory = objccategory external name 'UITextField' (UIView)
    function endEditing(force: Boolean): Boolean; message 'endEditing:';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UITEXTFIELD_PAS_P}
{$define UITEXTFIELD_PAS_P}
  
{ UITextFieldDelegate Protocol }
  UITextFieldDelegateProtocol = objcprotocol external name 'UITextFieldDelegate'
  optional
    function textFieldShouldBeginEditing(textField: UITextField): Boolean; message 'textFieldShouldBeginEditing:';
    procedure textFieldDidBeginEditing(textField: UITextField); message 'textFieldDidBeginEditing:';
    function textFieldShouldEndEditing(textField: UITextField): Boolean; message 'textFieldShouldEndEditing:';
    procedure textFieldDidEndEditing(textField: UITextField); message 'textFieldDidEndEditing:';
    function textField_shouldChangeCharactersInRange_replacementString(textField: UITextField; range: NSRange; string_: NSString): Boolean; message 'textField:shouldChangeCharactersInRange:replacementString:';
    function textFieldShouldClear(textField: UITextField): Boolean; message 'textFieldShouldClear:';
    function textFieldShouldReturn(textField: UITextField): Boolean; message 'textFieldShouldReturn:';
  end;
{$endif}
{$endif}
