{ Parsed from Uikit.framework UITextInput.h }

{$ifdef TYPES}
{$ifndef UITEXTINPUT_PAS_T}
{$define UITEXTINPUT_PAS_T}

{ Types }
type
  
  UITextStorageDirection = culong;
  UITextLayoutDirection = culong;
  UITextWritingDirection = culong;
  UITextGranularity = culong;

{ Constants }

const
  UITextStorageDirectionForward = 0;
  UITextStorageDirectionBackward = 1;

const
  UITextLayoutDirectionRight = 2;
  UITextLayoutDirectionLeft = 3;
  UITextLayoutDirectionUp = 4;
  UITextLayoutDirectionDown = 5;

const
  UITextWritingDirectionNatural = -1;
  UITextWritingDirectionLeftToRight = 0;
  UITextWritingDirectionRightToLeft = 1;

const
  UITextGranularityCharacter = 0;
  UITextGranularityWord = 1;
  UITextGranularitySentence = 2;
  UITextGranularityParagraph = 3;
  UITextGranularityLine = 4;
  UITextGranularityDocument = 5;

{ Types }
type
  UITextDirection = NSInteger;
  UITextDirectionPtr = ^UITextDirection;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UITEXTINPUT_PAS_R}
{$define UITEXTINPUT_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UITEXTINPUT_PAS_F}
{$define UITEXTINPUT_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UITEXTINPUT_PAS_S}
{$define UITEXTINPUT_PAS_S}

{ External string constants }
var
  UITextInputTextBackgroundColorKey: NSString; cvar; external;
  UITextInputTextColorKey: NSString; cvar; external;
  UITextInputTextFontKey: NSString; cvar; external;
  UITextInputCurrentInputModeDidChangeNotification: NSString; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UIKeyInputProtocol = objcprotocol;
  UITextInputProtocol = objcprotocol;
  UITextInputDelegateProtocol = objcprotocol;
  UITextInputTokenizerProtocol = objcprotocol;
  UITextPosition = objcclass;
  UITextPositionPointer = ^UITextPosition;
  UITextPositionPtr = UITextPositionPointer;
  UITextRange = objcclass;
  UITextRangePointer = ^UITextRange;
  UITextRangePtr = UITextRangePointer;
  UITextInputStringTokenizer = objcclass;
  UITextInputStringTokenizerPointer = ^UITextInputStringTokenizer;
  UITextInputStringTokenizerPtr = UITextInputStringTokenizerPointer;
  UITextInputMode = objcclass;
  UITextInputModePointer = ^UITextInputMode;
  UITextInputModePtr = UITextInputModePointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UITEXTINPUT_PAS_C}
{$define UITEXTINPUT_PAS_C}

{ UITextPosition }
  UITextPosition = objcclass external (NSObject)
    
  public
  end;

{ UITextRange }
  UITextRange = objcclass external (NSObject)
    
  public
    function isEmpty: Boolean; message 'isEmpty';
    function start: UITextPosition; message 'start';
    function end_: UITextPosition; message 'end_';
  end;

{ UITextInputStringTokenizer }
  UITextInputStringTokenizer = objcclass external (NSObject, UITextInputTokenizerProtocol)
  private
    _textInput: UIResponder;
    
  public
    function initWithTextInput(textInput: UIResponder): id; message 'initWithTextInput:';

    { Adopted Protocols }
    function rangeEnclosingPosition_withGranularity_inDirection(position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): UITextRange;
    function isPosition_atBoundary_inDirection(position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): Boolean;
    function positionFromPosition_toBoundary_inDirection(position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): UITextPosition;
    function isPosition_withinTextUnit_inDirection(position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): Boolean;
  end;

{ UITextInputMode }
  UITextInputMode = objcclass external (NSObject)
    
  public
    function primaryLanguage: NSString; message 'primaryLanguage';
    class function currentInputMode: UITextInputMode; message 'currentInputMode';
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UITEXTINPUT_PAS_P}
{$define UITEXTINPUT_PAS_P}
  
{ UIKeyInput Protocol }
  UIKeyInputProtocol = objcprotocol external name 'UIKeyInput'
    function hasText: Boolean; message 'hasText';
    procedure insertText(text: NSString); message 'insertText:';
    procedure deleteBackward; message 'deleteBackward';
  end;
  
{ UITextInput Protocol }
  UITextInputProtocol = objcprotocol external name 'UITextInput'
  required
    function textInRange(range: UITextRange): NSString; message 'textInRange:';
    procedure replaceRange_withText(range: UITextRange; text: NSString); message 'replaceRange:withText:';
    procedure setSelectedTextRange (newValue: UITextRange); message 'setSelectedTextRange:';
    function selectedTextRange: UITextRange; message 'selectedTextRange';
    function markedTextRange: UITextRange; message 'markedTextRange';
    procedure setMarkedTextStyle (newValue: NSDictionary); message 'setMarkedTextStyle:';
    function markedTextStyle: NSDictionary; message 'markedTextStyle';
    procedure setMarkedText_selectedRange(markedText: NSString; selectedRange: NSRange); message 'setMarkedText:selectedRange:';
    procedure unmarkText; message 'unmarkText';
    function beginningOfDocument: UITextPosition; message 'beginningOfDocument';
    function endOfDocument: UITextPosition; message 'endOfDocument';
    function textRangeFromPosition_toPosition(fromPosition: UITextPosition; toPosition: UITextPosition): UITextRange; message 'textRangeFromPosition:toPosition:';
    function positionFromPosition_offset(position: UITextPosition; offset: NSInteger): UITextPosition; message 'positionFromPosition:offset:';
    function positionFromPosition_inDirection_offset(position: UITextPosition; direction: UITextLayoutDirection; offset: NSInteger): UITextPosition; message 'positionFromPosition:inDirection:offset:';
    function comparePosition_toPosition(position: UITextPosition; other: UITextPosition): NSComparisonResult; message 'comparePosition:toPosition:';
    function offsetFromPosition_toPosition(from: UITextPosition; toPosition: UITextPosition): NSInteger; message 'offsetFromPosition:toPosition:';
    procedure setInputDelegate (newValue: id); message 'setInputDelegate:';
    function inputDelegate: id; message 'inputDelegate';
    function tokenizer: id; message 'tokenizer';
    function positionWithinRange_farthestInDirection(range: UITextRange; direction: UITextLayoutDirection): UITextPosition; message 'positionWithinRange:farthestInDirection:';
    function characterRangeByExtendingPosition_inDirection(position: UITextPosition; direction: UITextLayoutDirection): UITextRange; message 'characterRangeByExtendingPosition:inDirection:';
    function baseWritingDirectionForPosition_inDirection(position: UITextPosition; direction: UITextStorageDirection): UITextWritingDirection; message 'baseWritingDirectionForPosition:inDirection:';
    procedure setBaseWritingDirection_forRange(writingDirection: UITextWritingDirection; range: UITextRange); message 'setBaseWritingDirection:forRange:';
    function firstRectForRange(range: UITextRange): CGRect; message 'firstRectForRange:';
    function caretRectForPosition(position: UITextPosition): CGRect; message 'caretRectForPosition:';
    function closestPositionToPoint(point: CGPoint): UITextPosition; message 'closestPositionToPoint:';
    function closestPositionToPoint_withinRange(point: CGPoint; range: UITextRange): UITextPosition; message 'closestPositionToPoint:withinRange:';
    function characterRangeAtPoint(point: CGPoint): UITextRange; message 'characterRangeAtPoint:';
  optional
    function textStylingAtPosition_inDirection(position: UITextPosition; direction: UITextStorageDirection): NSDictionary; message 'textStylingAtPosition:inDirection:';
    function positionWithinRange_atCharacterOffset(range: UITextRange; offset: NSInteger): UITextPosition; message 'positionWithinRange:atCharacterOffset:';
    function characterOffsetOfPosition_withinRange(position: UITextPosition; range: UITextRange): NSInteger; message 'characterOffsetOfPosition:withinRange:';
    function textInputView: UIView; message 'textInputView';
    procedure setSelectionAffinity (newValue: UITextStorageDirection); message 'setSelectionAffinity:';
    function selectionAffinity: UITextStorageDirection; message 'selectionAffinity';
  end;
  
{ UITextInputDelegate Protocol }
  UITextInputDelegateProtocol = objcprotocol external name 'UITextInputDelegate'
  optional
    procedure selectionWillChange(textInput: UITextInputProtocol); message 'selectionWillChange:';
    procedure selectionDidChange(textInput: UITextInputProtocol); message 'selectionDidChange:';
    procedure textWillChange(textInput: UITextInputProtocol); message 'textWillChange:';
    procedure textDidChange(textInput: UITextInputProtocol); message 'textDidChange:';
  end;
  
{ UITextInputTokenizer Protocol }
  UITextInputTokenizerProtocol = objcprotocol external name 'UITextInputTokenizer'
  required
    function rangeEnclosingPosition_withGranularity_inDirection(position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): UITextRange; message 'rangeEnclosingPosition:withGranularity:inDirection:';
    function isPosition_atBoundary_inDirection(position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): Boolean; message 'isPosition:atBoundary:inDirection:';
    function positionFromPosition_toBoundary_inDirection(position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): UITextPosition; message 'positionFromPosition:toBoundary:inDirection:';
    function isPosition_withinTextUnit_inDirection(position: UITextPosition; granularity: UITextGranularity; direction: UITextDirection): Boolean; message 'isPosition:withinTextUnit:inDirection:';
  end;
{$endif}
{$endif}
