{ Parsed from Uikit.framework UITextView.h }

{$ifdef TYPES}
{$ifndef UITEXTVIEW_PAS_T}
{$define UITEXTVIEW_PAS_T}

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UITEXTVIEW_PAS_R}
{$define UITEXTVIEW_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UITEXTVIEW_PAS_F}
{$define UITEXTVIEW_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UITEXTVIEW_PAS_S}
{$define UITEXTVIEW_PAS_S}

{ External string constants }
var
  UITextViewTextDidBeginEditingNotification: NSString; cvar; external;
  UITextViewTextDidChangeNotification: NSString; cvar; external;
  UITextViewTextDidEndEditingNotification: NSString; cvar; external;

{$endif}
{$endif}

{$ifdef FORWARD}
  UITextViewDelegateProtocol = objcprotocol;
  UITextView = objcclass;
  UITextViewPointer = ^UITextView;
  UITextViewPtr = UITextViewPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UITEXTVIEW_PAS_C}
{$define UITEXTVIEW_PAS_C}

{ UITextView }
  UITextView = objcclass external (UIScrollView, UITextInputTraitsProtocol)
  private
    m_frame: WebFrame;
    m_body: DOMHTMLElement;
    m_marginTop: cint;
    m_selectionTimer: UIDelayedAction;
    m_longPressAction: UIDelayedAction;
    m_editable: Boolean;
    m_editing: Boolean;
    m_becomesEditableWithGestures: Boolean;
    m_reentrancyGuard: Boolean;
    m_readyForScroll: Boolean;
    m_hasExplicitTextAlignment: Boolean;
    m_interactionAssistant: UITextInteractionAssistant;
    m_selectionView: UITextSelectionView;
    m_webView: UIWebDocumentView;
    m_font: UIFont;
    m_textColor: UIColor;
    m_textAlignment: UITextAlignment;
    m_inputView: UIView;
    m_inputAccessoryView: UIView;
    
  public
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure setText (newValue: NSString); message 'setText:';
    function text: NSString; message 'text';
    procedure setFont (newValue: UIFont); message 'setFont:';
    function font: UIFont; message 'font';
    procedure setTextColor (newValue: UIColor); message 'setTextColor:';
    function textColor: UIColor; message 'textColor';
    procedure setTextAlignment (newValue: UITextAlignment); message 'setTextAlignment:';
    function textAlignment: UITextAlignment; message 'textAlignment';
    procedure setSelectedRange (newValue: NSRange); message 'setSelectedRange:';
    function selectedRange: NSRange; message 'selectedRange';
    procedure setEditable (newValue: Boolean); message 'setEditable:';
    function isEditable: Boolean; message 'isEditable';
    procedure setDataDetectorTypes (newValue: UIDataDetectorTypes); message 'setDataDetectorTypes:';
    function dataDetectorTypes: UIDataDetectorTypes; message 'dataDetectorTypes';
    function hasText: Boolean; message 'hasText';
    procedure scrollRangeToVisible(range: NSRange); message 'scrollRangeToVisible:';
    procedure setInputView (newValue: UIView); message 'setInputView:';
    function inputView: UIView; message 'inputView';
    procedure setInputAccessoryView (newValue: UIView); message 'setInputAccessoryView:';
    function inputAccessoryView: UIView; message 'inputAccessoryView';

    { Adopted Protocols }
    procedure setAutocapitalizationType (newValue: UITextAutocapitalizationType);
    function autocapitalizationType: UITextAutocapitalizationType;
    procedure setAutocorrectionType (newValue: UITextAutocorrectionType);
    function autocorrectionType: UITextAutocorrectionType;
    procedure setKeyboardType (newValue: UIKeyboardType);
    function keyboardType: UIKeyboardType;
    procedure setKeyboardAppearance (newValue: UIKeyboardAppearance);
    function keyboardAppearance: UIKeyboardAppearance;
    procedure setReturnKeyType (newValue: UIReturnKeyType);
    function returnKeyType: UIReturnKeyType;
    procedure setEnablesReturnKeyAutomatically (newValue: Boolean);
    function enablesReturnKeyAutomatically: Boolean;
    procedure setSecureTextEntry (newValue: Boolean);
    function isSecureTextEntry: Boolean;
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UITEXTVIEW_PAS_P}
{$define UITEXTVIEW_PAS_P}
  
{ UITextViewDelegate Protocol }
  UITextViewDelegateProtocol = objcprotocol external name 'UITextViewDelegate'
  optional
    function textViewShouldBeginEditing(textView: UITextView): Boolean; message 'textViewShouldBeginEditing:';
    function textViewShouldEndEditing(textView: UITextView): Boolean; message 'textViewShouldEndEditing:';
    procedure textViewDidBeginEditing(textView: UITextView); message 'textViewDidBeginEditing:';
    procedure textViewDidEndEditing(textView: UITextView); message 'textViewDidEndEditing:';
    function textView_shouldChangeTextInRange_replacementText(textView: UITextView; range: NSRange; text: NSString): Boolean; message 'textView:shouldChangeTextInRange:replacementText:';
    procedure textViewDidChange(textView: UITextView); message 'textViewDidChange:';
    procedure textViewDidChangeSelection(textView: UITextView); message 'textViewDidChangeSelection:';
  end;
{$endif}
{$endif}
