{ Parsed from Uikit.framework UITouch.h }

{$ifdef TYPES}
{$ifndef UITOUCH_PAS_T}
{$define UITOUCH_PAS_T}

{ Types }
type
  
  UITouchPhase = culong;

{ Constants }

const
  UITouchPhaseBegan = 0;
  UITouchPhaseMoved = 1;
  UITouchPhaseStationary = 2;
  UITouchPhaseEnded = 3;
  UITouchPhaseCancelled = 4;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UITOUCH_PAS_R}
{$define UITOUCH_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UITOUCH_PAS_F}
{$define UITOUCH_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UITOUCH_PAS_S}
{$define UITOUCH_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UITouch = objcclass;
  UITouchPointer = ^UITouch;
  UITouchPtr = UITouchPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UITOUCH_PAS_C}
{$define UITOUCH_PAS_C}

{ UITouch }
  UITouch = objcclass external (NSObject)
  private
    _timestamp: NSTimeInterval;
    _phase: UITouchPhase;
    _savedPhase: UITouchPhase;
    _tapCount: NSUInteger;
    _window: UIWindow;
    _view: UIView;
    _gestureView: UIView;
    _gestureRecognizers: NSMutableArray;
    _locationInWindow: CGPoint;
    _previousLocationInWindow: CGPoint;
    _pathIndex: UInt8;
    _pathIdentity: UInt8;
    _pathMajorRadius: single;
    __touchFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UITouch0: cuint);
       1: (
        _firstTouchForView: 0..1;
        _isTap: 0..1;
        _isWarped: 0..1;
        _isDelayed: 0..1;
        _sentTouchesEnded: 0..1;
      );
      end;
    
  public
    function timestamp: NSTimeInterval; message 'timestamp';
    function phase: UITouchPhase; message 'phase';
    function tapCount: NSUInteger; message 'tapCount';
    function window: UIWindow; message 'window';
    function view: UIView; message 'view';
    function gestureRecognizers: NSArray; message 'gestureRecognizers';
    function locationInView(view_: UIView): CGPoint; message 'locationInView:';
    function previousLocationInView(view_: UIView): CGPoint; message 'previousLocationInView:';
  end;

{$endif}
{$endif}
