{ Parsed from Uikit.framework UIView.h }

{$ifdef TYPES}
{$ifndef UIVIEW_PAS_T}
{$define UIVIEW_PAS_T}

{ Types }
type
  
  UIViewAnimationCurve = culong;
  UIViewContentMode = culong;
  UIViewAnimationTransition = culong;

{ Constants }

const
  UIViewAnimationCurveEaseInOut = 0;
  UIViewAnimationCurveEaseIn = 1;
  UIViewAnimationCurveEaseOut = 2;
  UIViewAnimationCurveLinear = 3;

const
  UIViewContentModeScaleToFill = 0;
  UIViewContentModeScaleAspectFit = 1;
  UIViewContentModeScaleAspectFill = 2;
  UIViewContentModeRedraw = 3;
  UIViewContentModeCenter = 4;
  UIViewContentModeTop = 5;
  UIViewContentModeBottom = 6;
  UIViewContentModeLeft = 7;
  UIViewContentModeRight = 8;
  UIViewContentModeTopLeft = 9;
  UIViewContentModeTopRight = 10;
  UIViewContentModeBottomLeft = 11;
  UIViewContentModeBottomRight = 12;

const
  UIViewAnimationTransitionNone = 0;
  UIViewAnimationTransitionFlipFromLeft = 1;
  UIViewAnimationTransitionFlipFromRight = 2;
  UIViewAnimationTransitionCurlUp = 3;
  UIViewAnimationTransitionCurlDown = 4;

const
  UIViewAutoresizingNone = 0;
  UIViewAutoresizingFlexibleLeftMargin = 1 shl 0;
  UIViewAutoresizingFlexibleWidth = 1 shl 1;
  UIViewAutoresizingFlexibleRightMargin = 1 shl 2;
  UIViewAutoresizingFlexibleTopMargin = 1 shl 3;
  UIViewAutoresizingFlexibleHeight = 1 shl 4;
  UIViewAutoresizingFlexibleBottomMargin = 1 shl 5;

const
  UIViewAnimationOptionLayoutSubviews = 1 shl  0;
  UIViewAnimationOptionAllowUserInteraction = 1 shl  1;
  UIViewAnimationOptionBeginFromCurrentState = 1 shl  2;
  UIViewAnimationOptionRepeat = 1 shl  3;
  UIViewAnimationOptionAutoreverse = 1 shl  4;
  UIViewAnimationOptionOverrideInheritedDuration = 1 shl  5;
  UIViewAnimationOptionOverrideInheritedCurve = 1 shl  6;
  UIViewAnimationOptionAllowAnimatedContent = 1 shl  7;
  UIViewAnimationOptionShowHideTransitionViews = 1 shl  8;
  UIViewAnimationOptionCurveEaseInOut = 0 shl 16;
  UIViewAnimationOptionCurveEaseIn = 1 shl 16;
  UIViewAnimationOptionCurveEaseOut = 2 shl 16;
  UIViewAnimationOptionCurveLinear = 3 shl 16;
  UIViewAnimationOptionTransitionNone = 0 shl 20;
  UIViewAnimationOptionTransitionFlipFromLeft = 1 shl 20;
  UIViewAnimationOptionTransitionFlipFromRight = 2 shl 20;
  UIViewAnimationOptionTransitionCurlUp = 3 shl 20;
  UIViewAnimationOptionTransitionCurlDown = 4 shl 20;

{ Types }
type
  UIViewAutoresizing = NSUInteger;
  UIViewAutoresizingPtr = ^UIViewAutoresizing;
  UIViewAnimationOptions = NSUInteger;
  UIViewAnimationOptionsPtr = ^UIViewAnimationOptions;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIVIEW_PAS_R}
{$define UIVIEW_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIVIEW_PAS_F}
{$define UIVIEW_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIVIEW_PAS_S}
{$define UIVIEW_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIView = objcclass;
  UIViewPointer = ^UIView;
  UIViewPtr = UIViewPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIVIEW_PAS_C}
{$define UIVIEW_PAS_C}

{ UIView }
  UIView = objcclass external (UIResponder, NSCodingProtocol)
  private
    _layer: CALayer;
    _tapInfo: id;
    _gestureInfo: id;
    _gestureRecognizers: NSMutableArray;
    _subviewCache: NSArray;
    _charge: single;
    _tag: NSInteger;
    _viewDelegate: UIViewController;
    __viewFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIView0: cuint);
       1: (
        userInteractionDisabled: 0..1;
        implementsDrawRect: 0..1;
        implementsDidScroll: 0..1;
        implementsMouseTracking: 0..1;
        hasBackgroundColor: 0..1;
        isOpaque: 0..1;
        becomeFirstResponderWhenCapable: 0..1;
        interceptMouseEvent: 0..1;
        deallocating: 0..1;
        debugFlash: 0..1;
        debugSkippedSetNeedsDisplay: 0..1;
        debugScheduledDisplayIsRequired: 0..1;
        isInAWindow: 0..1;
        isAncestorOfFirstResponder: 0..1;
        dontAutoresizeSubviews: 0..1;
        autoresizeMask: 0..((1 shl 6)-1);
        patternBackground: 0..1;
        fixedBackgroundPattern: 0..1;
        dontAnimate: 0..1;
        superLayerIsView: 0..1;
        layerKitPatternDrawing: 0..1;
        multipleTouchEnabled: 0..1;
        exclusiveTouch: 0..1;
        hasViewController: 0..1;
        needsDidAppearOrDisappear: 0..1;
        gesturesEnabled: 0..1;
        deliversTouchesForGesturesToSuperview: 0..1;
        chargeEnabled: 0..1;
        skipsSubviewEnumeration: 0..1;
        needsDisplayOnBoundsChange: 0..1;
        hasTiledLayer: 0..1;
        hasLargeContent: 0..1;
        alwaysScaleContent: 0..1;
      );
      end;
    
  public
    class function layerClass: Pobjc_class; message 'layerClass';
    function initWithFrame(frame: CGRect): id; message 'initWithFrame:';
    procedure setUserInteractionEnabled (newValue: Boolean); message 'setUserInteractionEnabled:';
    function isUserInteractionEnabled: Boolean; message 'isUserInteractionEnabled';
    procedure setTag (newValue: NSInteger); message 'setTag:';
    function tag: NSInteger; message 'tag';
    function layer: CALayer; message 'layer';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{ UIViewGeometryCategory }
  UIViewGeometryCategory = objccategory external (UIView)
    procedure setFrame (newValue: CGRect); message 'setFrame:';
    function frame: CGRect; message 'frame';
    procedure setBounds (newValue: CGRect); message 'setBounds:';
    function bounds: CGRect; message 'bounds';
    procedure setCenter (newValue: CGPoint); message 'setCenter:';
    function center: CGPoint; message 'center';
    procedure setTransform (newValue: CGAffineTransform); message 'setTransform:';
    function transform: CGAffineTransform; message 'transform';
    procedure setContentScaleFactor (newValue: CGFloat); message 'setContentScaleFactor:';
    function contentScaleFactor: CGFloat; message 'contentScaleFactor';
    procedure setMultipleTouchEnabled (newValue: Boolean); message 'setMultipleTouchEnabled:';
    function isMultipleTouchEnabled: Boolean; message 'isMultipleTouchEnabled';
    procedure setExclusiveTouch (newValue: Boolean); message 'setExclusiveTouch:';
    function isExclusiveTouch: Boolean; message 'isExclusiveTouch';
    function hitTest_withEvent(point: CGPoint; event: UIEvent): UIView; message 'hitTest:withEvent:';
    function pointInside_withEvent(point: CGPoint; event: UIEvent): Boolean; message 'pointInside:withEvent:';
    function convertPoint_toView(point: CGPoint; view: UIView): CGPoint; message 'convertPoint:toView:';
    function convertPoint_fromView(point: CGPoint; view: UIView): CGPoint; message 'convertPoint:fromView:';
    function convertRect_toView(rect: CGRect; view: UIView): CGRect; message 'convertRect:toView:';
    function convertRect_fromView(rect: CGRect; view: UIView): CGRect; message 'convertRect:fromView:';
    procedure setAutoresizesSubviews (newValue: Boolean); message 'setAutoresizesSubviews:';
    function autoresizesSubviews: Boolean; message 'autoresizesSubviews';
    procedure setAutoresizingMask (newValue: UIViewAutoresizing); message 'setAutoresizingMask:';
    function autoresizingMask: UIViewAutoresizing; message 'autoresizingMask';
    function sizeThatFits(size: CGSize): CGSize; message 'sizeThatFits:';
    procedure sizeToFit; message 'sizeToFit';
  end;

{ UIViewHierarchyCategory }
  UIViewHierarchyCategory = objccategory external (UIView)
    function superview: UIView; message 'superview';
    function subviews: NSArray; message 'subviews';
    function window: UIWindow; message 'window';
    procedure removeFromSuperview; message 'removeFromSuperview';
    procedure insertSubview_atIndex(view: UIView; index: NSInteger); message 'insertSubview:atIndex:';
    procedure exchangeSubviewAtIndex_withSubviewAtIndex(index: NSInteger; index1: NSInteger); message 'exchangeSubviewAtIndex:withSubviewAtIndex:';
    procedure addSubview(view: UIView); message 'addSubview:';
    procedure insertSubview_belowSubview(view: UIView; siblingSubview: UIView); message 'insertSubview:belowSubview:';
    procedure insertSubview_aboveSubview(view: UIView; siblingSubview: UIView); message 'insertSubview:aboveSubview:';
    procedure bringSubviewToFront(view: UIView); message 'bringSubviewToFront:';
    procedure sendSubviewToBack(view: UIView); message 'sendSubviewToBack:';
    procedure didAddSubview(subview: UIView); message 'didAddSubview:';
    procedure willRemoveSubview(subview: UIView); message 'willRemoveSubview:';
    procedure willMoveToSuperview(newSuperview: UIView); message 'willMoveToSuperview:';
    procedure didMoveToSuperview; message 'didMoveToSuperview';
    procedure willMoveToWindow(newWindow: UIWindow); message 'willMoveToWindow:';
    procedure didMoveToWindow; message 'didMoveToWindow';
    function isDescendantOfView(view: UIView): Boolean; message 'isDescendantOfView:';
    function viewWithTag(tag_: NSInteger): UIView; message 'viewWithTag:';
    procedure setNeedsLayout; message 'setNeedsLayout';
    procedure layoutIfNeeded; message 'layoutIfNeeded';
    procedure layoutSubviews; message 'layoutSubviews';
  end;

{ UIViewRenderingCategory }
  UIViewRenderingCategory = objccategory external (UIView)
    procedure drawRect(rect: CGRect); message 'drawRect:';
    procedure setNeedsDisplay; message 'setNeedsDisplay';
    procedure setNeedsDisplayInRect(rect: CGRect); message 'setNeedsDisplayInRect:';
    procedure setClipsToBounds (newValue: Boolean); message 'setClipsToBounds:';
    function clipsToBounds: Boolean; message 'clipsToBounds';
    procedure setBackgroundColor (newValue: UIColor); message 'setBackgroundColor:';
    function backgroundColor: UIColor; message 'backgroundColor';
    procedure setAlpha (newValue: CGFloat); message 'setAlpha:';
    function alpha: CGFloat; message 'alpha';
    procedure setOpaque (newValue: Boolean); message 'setOpaque:';
    function isOpaque: Boolean; message 'isOpaque';
    procedure setClearsContextBeforeDrawing (newValue: Boolean); message 'setClearsContextBeforeDrawing:';
    function clearsContextBeforeDrawing: Boolean; message 'clearsContextBeforeDrawing';
    procedure setHidden (newValue: Boolean); message 'setHidden:';
    function isHidden: Boolean; message 'isHidden';
    procedure setContentMode (newValue: UIViewContentMode); message 'setContentMode:';
    function contentMode: UIViewContentMode; message 'contentMode';
    procedure setContentStretch (newValue: CGRect); message 'setContentStretch:';
    function contentStretch: CGRect; message 'contentStretch';
  end;

{ UIViewAnimationCategory }
  UIViewAnimationCategory = objccategory external (UIView)
    class procedure beginAnimations_context(animationID: NSString; context: Pointer); message 'beginAnimations:context:';
    class procedure commitAnimations; message 'commitAnimations';
    class procedure setAnimationDelegate(delegate: id); message 'setAnimationDelegate:';
    class procedure setAnimationWillStartSelector(selector: SEL); message 'setAnimationWillStartSelector:';
    class procedure setAnimationDidStopSelector(selector: SEL); message 'setAnimationDidStopSelector:';
    class procedure setAnimationDuration(duration: NSTimeInterval); message 'setAnimationDuration:';
    class procedure setAnimationDelay(delay: NSTimeInterval); message 'setAnimationDelay:';
    class procedure setAnimationStartDate(startDate: NSDate); message 'setAnimationStartDate:';
    class procedure setAnimationCurve(curve: UIViewAnimationCurve); message 'setAnimationCurve:';
    class procedure setAnimationRepeatCount(repeatCount: single); message 'setAnimationRepeatCount:';
    class procedure setAnimationRepeatAutoreverses(repeatAutoreverses: Boolean); message 'setAnimationRepeatAutoreverses:';
    class procedure setAnimationBeginsFromCurrentState(fromCurrentState: Boolean); message 'setAnimationBeginsFromCurrentState:';
    class procedure setAnimationTransition_forView_cache(transition: UIViewAnimationTransition; view: UIView; cache: Boolean); message 'setAnimationTransition:forView:cache:';
    class procedure setAnimationsEnabled(enabled: Boolean); message 'setAnimationsEnabled:';
    class function areAnimationsEnabled: Boolean; message 'areAnimationsEnabled';
  end;

{ UIViewAnimationWithBlocksCategory }
  UIViewAnimationWithBlocksCategory = objccategory external (UIView)
    // class procedure animateWithDuration_delay_options_animations_completion(duration: NSTimeInterval; delay: NSTimeInterval; options: UIViewAnimationOptions; animations: void (^)(void); completion: void (^)(BOOL finished)); message 'animateWithDuration:delay:options:animations:completion:';
    // class procedure animateWithDuration_animations_completion(duration: NSTimeInterval; animations: void (^)(void); completion: void (^)(BOOL finished)); message 'animateWithDuration:animations:completion:';
    // class procedure animateWithDuration_animations(duration: NSTimeInterval; animations: void (^)(void)); message 'animateWithDuration:animations:';
    // class procedure transitionWithView_duration_options_animations_completion(view: UIView; duration: NSTimeInterval; options: UIViewAnimationOptions; animations: void (^)(void); completion: void (^)(BOOL finished)); message 'transitionWithView:duration:options:animations:completion:';
    // class procedure transitionFromView_toView_duration_options_completion(fromView: UIView; toView: UIView; duration: NSTimeInterval; options: UIViewAnimationOptions; completion: void (^)(BOOL finished)); message 'transitionFromView:toView:duration:options:completion:';
  end;

{ UIViewGestureRecognizersCategory }
  UIViewGestureRecognizersCategory = objccategory external (UIView)
    procedure setGestureRecognizers (newValue: NSArray); message 'setGestureRecognizers:';
    function gestureRecognizers: NSArray; message 'gestureRecognizers';
    procedure addGestureRecognizer(gestureRecognizer: UIGestureRecognizer); message 'addGestureRecognizer:';
    procedure removeGestureRecognizer(gestureRecognizer: UIGestureRecognizer); message 'removeGestureRecognizer:';
  end;

{$endif}
{$endif}
