{ Parsed from Uikit.framework UIViewController.h }

{$ifdef TYPES}
{$ifndef UIVIEWCONTROLLER_PAS_T}
{$define UIVIEWCONTROLLER_PAS_T}

{ Types }
type
  
  UIModalTransitionStyle = culong;
  UIModalPresentationStyle = culong;

{ Constants }

const
  UIModalTransitionStyleCoverVertical = 0;
  UIModalTransitionStyleFlipHorizontal = 1;
  UIModalTransitionStyleCrossDissolve = 2;
  UIModalTransitionStylePartialCurl = 3;

const
  UIModalPresentationFullScreen = 0;
  UIModalPresentationPageSheet = 1;
  UIModalPresentationFormSheet = 2;
  UIModalPresentationCurrentContext = 3;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIVIEWCONTROLLER_PAS_R}
{$define UIVIEWCONTROLLER_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIVIEWCONTROLLER_PAS_F}
{$define UIVIEWCONTROLLER_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIVIEWCONTROLLER_PAS_S}
{$define UIVIEWCONTROLLER_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIViewController = objcclass;
  UIViewControllerPointer = ^UIViewController;
  UIViewControllerPtr = UIViewControllerPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIVIEWCONTROLLER_PAS_C}
{$define UIVIEWCONTROLLER_PAS_C}

{ UIViewController }
  UIViewController = objcclass external (UIResponder, NSCodingProtocol)
  private
    _view: UIView;
    _tabBarItem: UITabBarItem;
    _navigationItem: UINavigationItem;
    _toolbarItems: NSArray;
    _title: NSString;
    _nibName: NSString;
    _nibBundle: NSBundle;
    _parentViewController: UIViewController;
    _childViewControllers: NSHashTable;
    _childModalViewController: UIViewController;
    _parentModalViewController: UIViewController;
    _modalTransitionView: UIView;
    _modalPreservedFirstResponder: UIResponder;
    _defaultFirstResponder: UIResponder;
    _dimmingView: UIDimmingView;
    _dropShadowView: UIDropShadowView;
    _presentationSuperview: UIView;
    _sheetView: UIView;
    _currentAction: id;
    _savedHeaderSuperview: UIView;
    _savedFooterSuperview: UIView;
    _editButtonItem: UIBarButtonItem;
    _searchDisplayController: UISearchDisplayController;
    _popoverController: UIPopoverController;
    _modalTransitionStyle: UIModalTransitionStyle;
    _modalPresentationStyle: UIModalPresentationStyle;
    _lastKnownInterfaceOrientation: UIInterfaceOrientation;
    _contentSizeForViewInPopover: CGSize;
    _formSheetSize: CGSize;
    __viewControllerFlags: bitpacked record
      case byte of
       0: (_anonbitfield_UIViewController0: cuint);
       1: (
        appearState: 0..((1 shl 2)-1);
        isEditing: 0..1;
        isPerformingModalTransition: 0..1;
        hidesBottomBarWhenPushed: 0..1;
        autoresizesArchivedViewToFullSize: 0..1;
        viewLoadedFromControllerNib: 0..1;
        isRootViewController: 0..1;
        isSheet: 0..1;
        isSuspended: 0..1;
        wasApplicationFrameAtSuspend: 0..1;
        wantsFullScreenLayout: 0..1;
        shouldUseFullScreenLayout: 0..1;
        allowsAutorotation: 0..1;
        searchControllerRetained: 0..1;
        oldModalInPopover: 0..1;
        isModalInPopover: 0..1;
        restoreDeepestFirstResponder: 0..1;
        isInWillRotateCallback: 0..1;
        disallowMixedOrientationPresentations: cuint;
      );
      end;
    
  public
    function initWithNibName_bundle(nibNameOrNil: NSString; nibBundleOrNil: NSBundle): id; message 'initWithNibName:bundle:';
    procedure setView (newValue: UIView); message 'setView:';
    function view: UIView; message 'view';
    procedure loadView; message 'loadView';
    procedure viewDidLoad; message 'viewDidLoad';
    procedure viewDidUnload; message 'viewDidUnload';
    function isViewLoaded: Boolean; message 'isViewLoaded';
    function nibName: NSString; message 'nibName';
    function nibBundle: NSBundle; message 'nibBundle';
    procedure viewWillAppear(animated: Boolean); message 'viewWillAppear:';
    procedure viewDidAppear(animated: Boolean); message 'viewDidAppear:';
    procedure viewWillDisappear(animated: Boolean); message 'viewWillDisappear:';
    procedure viewDidDisappear(animated: Boolean); message 'viewDidDisappear:';
    procedure setTitle (newValue: NSString); message 'setTitle:';
    function title: NSString; message 'title';
    procedure didReceiveMemoryWarning; message 'didReceiveMemoryWarning';
    procedure presentModalViewController_animated(modalViewController: UIViewController; animated: Boolean); message 'presentModalViewController:animated:';
    procedure dismissModalViewControllerAnimated(animated: Boolean); message 'dismissModalViewControllerAnimated:';
    function modalViewController: UIViewController; message 'modalViewController';
    procedure setModalTransitionStyle (newValue: UIModalTransitionStyle); message 'setModalTransitionStyle:';
    function modalTransitionStyle: UIModalTransitionStyle; message 'modalTransitionStyle';
    procedure setModalPresentationStyle (newValue: UIModalPresentationStyle); message 'setModalPresentationStyle:';
    function modalPresentationStyle: UIModalPresentationStyle; message 'modalPresentationStyle';
    procedure setWantsFullScreenLayout (newValue: Boolean); message 'setWantsFullScreenLayout:';
    function wantsFullScreenLayout: Boolean; message 'wantsFullScreenLayout';
    function parentViewController: UIViewController; message 'parentViewController';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
  end;

{ UIViewControllerRotationCategory }
  UIViewControllerRotationCategory = objccategory external (UIViewController)
    function shouldAutorotateToInterfaceOrientation(toInterfaceOrientation: UIInterfaceOrientation): Boolean; message 'shouldAutorotateToInterfaceOrientation:';
    function rotatingHeaderView: UIView; message 'rotatingHeaderView';
    function rotatingFooterView: UIView; message 'rotatingFooterView';
    function interfaceOrientation: UIInterfaceOrientation; message 'interfaceOrientation';
    procedure willRotateToInterfaceOrientation_duration(toInterfaceOrientation: UIInterfaceOrientation; duration: NSTimeInterval); message 'willRotateToInterfaceOrientation:duration:';
    procedure didRotateFromInterfaceOrientation(fromInterfaceOrientation: UIInterfaceOrientation); message 'didRotateFromInterfaceOrientation:';
    procedure willAnimateRotationToInterfaceOrientation_duration(toInterfaceOrientation: UIInterfaceOrientation; duration: NSTimeInterval); message 'willAnimateRotationToInterfaceOrientation:duration:';
    procedure willAnimateFirstHalfOfRotationToInterfaceOrientation_duration(toInterfaceOrientation: UIInterfaceOrientation; duration: NSTimeInterval); message 'willAnimateFirstHalfOfRotationToInterfaceOrientation:duration:';
    procedure didAnimateFirstHalfOfRotationToInterfaceOrientation(toInterfaceOrientation: UIInterfaceOrientation); message 'didAnimateFirstHalfOfRotationToInterfaceOrientation:';
    procedure willAnimateSecondHalfOfRotationFromInterfaceOrientation_duration(fromInterfaceOrientation: UIInterfaceOrientation; duration: NSTimeInterval); message 'willAnimateSecondHalfOfRotationFromInterfaceOrientation:duration:';
  end;

{ UIViewControllerEditingCategory }
  UIViewControllerEditingCategory = objccategory external (UIViewController)
    procedure setEditing (newValue: Boolean); message 'setEditing:';
    function isEditing: Boolean; message 'isEditing';
    procedure setEditing_animated(editing: Boolean; animated: Boolean); message 'setEditing:animated:';
    function editButtonItem: UIBarButtonItem; message 'editButtonItem';
  end;

{ UISearchDisplayControllerSupportCategory }
  UISearchDisplayControllerSupportCategory = objccategory external (UIViewController)
    function searchDisplayController: UISearchDisplayController; message 'searchDisplayController';
  end;

{$endif}
{$endif}
