{ Parsed from Uikit.framework UIWebView.h }

{$ifdef TYPES}
{$ifndef UIWEBVIEW_PAS_T}
{$define UIWEBVIEW_PAS_T}

{ Constants }

const
  UIWebViewNavigationTypeLinkClicked = 0;
  UIWebViewNavigationTypeFormSubmitted = 1;
  UIWebViewNavigationTypeBackForward = 2;
  UIWebViewNavigationTypeReload = 3;
  UIWebViewNavigationTypeFormResubmitted = 4;
  UIWebViewNavigationTypeOther = 5;

{ Types }
type
  UIWebViewNavigationType = NSUInteger;
  UIWebViewNavigationTypePtr = ^UIWebViewNavigationType;

{$endif}
{$endif}

{$ifdef RECORDS}
{$ifndef UIWEBVIEW_PAS_R}
{$define UIWEBVIEW_PAS_R}

{$endif}
{$endif}

{$ifdef FUNCTIONS}
{$ifndef UIWEBVIEW_PAS_F}
{$define UIWEBVIEW_PAS_F}

{$endif}
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
{$ifndef UIWEBVIEW_PAS_S}
{$define UIWEBVIEW_PAS_S}

{$endif}
{$endif}

{$ifdef FORWARD}
  UIWebViewDelegateProtocol = objcprotocol;
  UIWebView = objcclass;
  UIWebViewPointer = ^UIWebView;
  UIWebViewPtr = UIWebViewPointer;

{$endif}

{$ifdef CLASSES}
{$ifndef UIWEBVIEW_PAS_C}
{$define UIWEBVIEW_PAS_C}

{ UIWebView }
  UIWebView = objcclass external (UIView, NSCodingProtocol, UIScrollViewDelegateProtocol)
    
  public
    procedure setDelegate (newValue: id); message 'setDelegate:';
    function delegate: id; message 'delegate';
    procedure loadRequest(request: NSURLRequest); message 'loadRequest:';
    procedure loadHTMLString_baseURL(string_: NSString; baseURL: NSURL); message 'loadHTMLString:baseURL:';
    procedure loadData_MIMEType_textEncodingName_baseURL(data: NSData; MIMEType: NSString; textEncodingName: NSString; baseURL: NSURL); message 'loadData:MIMEType:textEncodingName:baseURL:';
    function request: NSURLRequest; message 'request';
    procedure reload; message 'reload';
    procedure stopLoading; message 'stopLoading';
    procedure goBack; message 'goBack';
    procedure goForward; message 'goForward';
    function canGoBack: Boolean; message 'canGoBack';
    function canGoForward: Boolean; message 'canGoForward';
    function isLoading: Boolean; message 'isLoading';
    function stringByEvaluatingJavaScriptFromString(script: NSString): NSString; message 'stringByEvaluatingJavaScriptFromString:';
    procedure setScalesPageToFit (newValue: Boolean); message 'setScalesPageToFit:';
    function scalesPageToFit: Boolean; message 'scalesPageToFit';
    procedure setDetectsPhoneNumbers (newValue: Boolean); message 'setDetectsPhoneNumbers:'; deprecated 'in  __IPHONE_2_0 and later, in  and later';
    function detectsPhoneNumbers: Boolean; message 'detectsPhoneNumbers'; deprecated 'in  __IPHONE_2_0 and later, in  and later';
    procedure setDataDetectorTypes (newValue: UIDataDetectorTypes); message 'setDataDetectorTypes:';
    function dataDetectorTypes: UIDataDetectorTypes; message 'dataDetectorTypes';
    procedure setAllowsInlineMediaPlayback (newValue: Boolean); message 'setAllowsInlineMediaPlayback:';
    function allowsInlineMediaPlayback: Boolean; message 'allowsInlineMediaPlayback';
    procedure setMediaPlaybackRequiresUserAction (newValue: Boolean); message 'setMediaPlaybackRequiresUserAction:';
    function mediaPlaybackRequiresUserAction: Boolean; message 'mediaPlaybackRequiresUserAction';

    { Adopted Protocols }
    procedure encodeWithCoder(aCoder: NSCoder);
    function initWithCoder(aDecoder: NSCoder): id;
    procedure scrollViewDidScroll(scrollView: UIScrollView);
    procedure scrollViewDidZoom(scrollView: UIScrollView);
    procedure scrollViewWillBeginDragging(scrollView: UIScrollView);
    procedure scrollViewDidEndDragging_willDecelerate(scrollView: UIScrollView; decelerate: Boolean);
    procedure scrollViewWillBeginDecelerating(scrollView: UIScrollView);
    procedure scrollViewDidEndDecelerating(scrollView: UIScrollView);
    procedure scrollViewDidEndScrollingAnimation(scrollView: UIScrollView);
    function viewForZoomingInScrollView(scrollView: UIScrollView): UIView;
    procedure scrollViewWillBeginZooming_withView(scrollView: UIScrollView; view: UIView);
    procedure scrollViewDidEndZooming_withView_atScale(scrollView: UIScrollView; view: UIView; scale: single);
    function scrollViewShouldScrollToTop(scrollView: UIScrollView): Boolean;
    procedure scrollViewDidScrollToTop(scrollView: UIScrollView);
  end;

{$endif}
{$endif}
{$ifdef PROTOCOLS}
{$ifndef UIWEBVIEW_PAS_P}
{$define UIWEBVIEW_PAS_P}
  
{ UIWebViewDelegate Protocol }
  UIWebViewDelegateProtocol = objcprotocol external name 'UIWebViewDelegate'
  optional
    function webView_shouldStartLoadWithRequest_navigationType(webView: UIWebView; request: NSURLRequest; navigationType: UIWebViewNavigationType): Boolean; message 'webView:shouldStartLoadWithRequest:navigationType:';
    procedure webViewDidStartLoad(webView: UIWebView); message 'webViewDidStartLoad:';
    procedure webViewDidFinishLoad(webView: UIWebView); message 'webViewDidFinishLoad:';
    procedure webView_didFailLoadWithError(webView: UIWebView; error: NSError); message 'webView:didFailLoadWithError:';
  end;
{$endif}
{$endif}
